#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/actions.c,v 1.1 94/02/01 16:37:09 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/actions.c,v 1.1 94/02/01 16:37:09 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  actions.c - Functions to collate and manage actions associated with windows.

*****************************************************************************/

#include "defs.h"

#include <X11/Intrinsic.h>
#include <Xm/Form.h>

#include "windows.h"
#include "actions.h"
#include "objects.h"
#include "layout.h"
#include "configure.h"
#include "xutil.h"
#include "y.tab.h"

/***************************************************
 *
 *	Globals...
 *
 */

int action_number = 0;
XLUobjectAction actions[MAXACTIONS];

/***************************************************
 *
 *	Externals....
 *
 */

extern Display *dpy;
extern XLUwindowTemplate win_templates[];

extern void doAbortRequest();

/***************************************************
 *
 *	Local funcs...
 *
 */

static void doPrimitiveSensitivityAux();

/*****************************************************************************
 * XLUsaveContextData()
 *
 * Save context data with each primitive object. This being the type
 * of the primitive (e.g. BUTTON, STATUS, MODIFY, etc.) and the identifier
 * of any associated action.
 *
 ****************************************************************************/

void XLUsaveContextData(template, tree, objid)
     WidgetTree tree;
     XLUlayoutObject template;
     int objid;
{
  XLUlayoutObject sub_template;
  Widget widget, active;
  Arg args[MAXARGS];
  int action_id;

  while (template != NULLLayout)
    {
      if (template->ref == REF_layout)
	{
	  sub_template =
	    win_templates[template->reference.layout_ref_id]->layout;

	  XLUsaveContextData(sub_template, tree->descendants, objid);
	}
      else
	{
	  if (template->action_list != NULLPrimActionList)
	    action_id = template->action_list->prim_action_id;
	  else
	    action_id = ActionUndefined;

	  widget = tree->this_widget;

	  switch (template->reference.primitive_id)
	    {
	    case MOVETO:
	      
	      active = XtNameToWidget(widget, "movetoDialog");
	      XLUsavePrimitiveContext(active, MOVETO, action_id);
	      
	      break;

	    case ENTRY_LIST:

	      XtSetArg(args[0], XmNworkWindow, &active);
	      XtGetValues(widget, args, 1);

	      XLUsavePrimitiveContext(active, ENTRY_LIST, action_id);
	      break;

	    case SEARCH_LOG:

	      XtSetArg(args[0], XmNworkWindow, &active);
	      XtGetValues(widget, args, 1);

	      XLUsavePrimitiveContext(active, SEARCH_LOG, action_id);
	      break;

	    default:

	      XLUsavePrimitiveContext(widget,
				      template->reference.primitive_id,
				      action_id);
	      break;
	    }
	}

      /***************************************************
       *
       * Other context initializers
       * (this may be the wrong place to put this).
       *
       */

      if (template->ref == REF_primitive)
	{
	  extern void initModifyStateData();

	  widget = tree->this_widget;

	  switch (template->reference.primitive_id)
	    {
	    case MODIFY:
	      
	      initModifyStateData(widget);
	      break;
	    }
	}

      template = template->next;
      tree = tree->left_siblings;
    }
} /* XLUsaveContextData */

/*****************************************************************************
 * XLUfindOutputObject()
 *
 * 
 *
 ****************************************************************************/

Widget XLUfindOutputObject(originator_id, output_template_id, mode, output_id_ptr)
     int originator_id;
     int output_template_id;
     XLUwindowMode mode;
     int *output_id_ptr;
{
  Widget output_shell = NULLWidget;

  switch (mode)
    {
    case NewWhenKeptLocal:

      *output_id_ptr = XLUfindUnkeptChild(originator_id, output_template_id);
      if (*output_id_ptr < MAXWINDOWS && XLUisWaiting(*output_id_ptr) == FALSE)
	{
	  output_shell = XLUgetWindowObject(*output_id_ptr)->parent_shell;
/*	  XRaiseWindow(dpy, XtWindow(output_shell)); */
	}
      else
	{
	  output_shell = XLUmakeWindowObject(output_template_id,
					     NULLWidget,
					     (int *) NULL,
					     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenKeptGlobal:

      *output_id_ptr = XLUfindUnkeptObject(output_template_id);
      if (*output_id_ptr < MAXWINDOWS && XLUisWaiting(*output_id_ptr) == FALSE)
	{
	  output_shell = XLUgetWindowObject(*output_id_ptr)->parent_shell;
	  XRaiseWindow(dpy, XtWindow(output_shell));
	}
      else
	{
	  output_shell = XLUmakeWindowObject(output_template_id,
				     NULLWidget,
				     (int *) NULL,
				     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenNone:

      /* ## To do ## */
      break;
      
    case CurrentWin:

      *output_id_ptr = originator_id;
      output_shell = XLUgetWindowObject(*output_id_ptr)->parent_shell;

      XRaiseWindow(dpy, XtWindow(output_shell));
      break;

    case NewAlways:

      output_shell = XLUmakeWindowObject (output_template_id,
					  NULLWidget,
					  &originator_id,
					  output_id_ptr);

      XtRealizeWidget(output_shell);
      XtPopup(output_shell, XtGrabNone);

      break;
    }

  doPrimitiveSensitivity(*output_id_ptr);

  /***************************************************
   *
   * If there are requests outstanding
   * then abandon these.
   *
   */

  doAbortRequest(NULLWidget, *output_id_ptr,0, ActionUndefined, NULLActionList);
  return output_shell;
} /* XLUfindOutputObject */

/*****************************************************************************
 * XLUgetOutputTemplateID()
 *
 * Get the output template ID associated with the given output type.
 *
 ****************************************************************************/

BOOLEAN XLUgetOutputTemplateID(deflist, type, idptr)
     XLUoutputDef deflist;
     XLUoutputType type;
     int *idptr;
{
  XLUoutputDef def;

  for (def = deflist; def != (XLUoutputDef) NULL; def = def->next)
    if (def->type == type)
      {
	*idptr = def->outputTmplID;
	return TRUE;
      }

  return FALSE;
} /* XLUgetOutputTemplateID */

/*****************************************************************************
 * doPrimitiveSensitivity()
 *
 * 
 *
 ****************************************************************************/

void doPrimitiveSensitivity(objid)
     int objid;
{
  XLUwindowObject this_object;
  WidgetTree curr_widget;
  XLUlayoutObject curr_member;
  char object_state = 0;
  char orbuf[LINESIZE];

  extern void GetORAddress();
  
  this_object = XLUgetWindowObject(objid);

  curr_widget = this_object->widget_layout->descendants;
  curr_member = win_templates[this_object->template_id]->layout;

  /* Waiting for a request? */
  if (XLUisWaiting(objid) == TRUE)
    object_state = I_DS_WAIT;
  else
    object_state = I_NORMAL;
  
  /* Check for a "current entry" */
  if (this_object->current_entry == NULLEntryList ||
      *this_object->current_entry->string_dn == '\0')
    object_state = object_state | I_NO_ENTRY;
  else
    /* Does the current entry have a useable mail address */
    {
      GetORAddress(this_object->current_entry->entry, orbuf);
      if (isnull(*orbuf))
	object_state = object_state | I_NO_MAIL;
    }

  /* Check for "current list" of entries */
  if (this_object->current_list == NULLEntryList)
    object_state = object_state | I_NO_LIST;

  /* Check for "current errors" list */
  if (this_object->current_errors == NULLError)
    object_state = object_state | I_NO_ERROR;
  
  doPrimitiveSensitivityAux(curr_member, curr_widget, object_state);
} /* doPrimitiveSensitivity */

/*****************************************************************************
 * doPrimitiveSensitivityAux()
 *
 * 
 *
 ****************************************************************************/

static void doPrimitiveSensitivityAux(curr_member,
				      curr_widget,
				      object_state)
     XLUlayoutObject curr_member;
     WidgetTree curr_widget;
     char object_state;
{
  char insensitivity;
  Widget prim_widget;

  while (curr_member != NULLLayout)
    {
      switch (curr_member->ref)
	{
	case REF_layout:
	  
	  doPrimitiveSensitivityAux
	    (win_templates[curr_member->reference.layout_ref_id]->layout,
	     curr_widget->descendants,
	     object_state);
	  
	  break;

	case REF_primitive:
	  
	  prim_widget = curr_widget->this_widget;
	  insensitivity = curr_member->insensitivity;
	  
	  if ((insensitivity & object_state) != 0)
	    {
	      if (XtIsSensitive(prim_widget) == TRUE) 
		XtSetSensitive(prim_widget, FALSE);
	    }
	  else
	    {
	      if (XtIsSensitive(prim_widget) == FALSE)
		XtSetSensitive(prim_widget, TRUE);
	    }
	  
	  break;
	}

      curr_member = curr_member->next;
      curr_widget = curr_widget->left_siblings;
    }
} /* doPrimitiveSensitivityAux */

/*****************************************************************************
 * getActionByName()
 *
 * 
 *
 ****************************************************************************/

int getActionByName(name)
     String name;
{
  XLUobjectAction action;
  int id;
  
  for (id = 0; id < action_number;  id++)
    {
      action = actions[id];
      if (lexequ(action->action_name, name) == 0)
	{
	  return id;
	}
    }

  return ActionUndefined;
} /* getActionByName */
