#ifndef _Xlu_actions_h_
#define _Xlu_actions_h_

#include "defs.h"
#include "layout.h"
#include "windows.h"

#define MAXACTIONS 1024

/* String defining mapping of an event to an output window. */
typedef enum {XLUraise, XLUlogTo, XLUoneHit, XLUmanyHits} XLUoutputType;

typedef struct XLUoutputDef
{
  XLUoutputType type;
  int outputTmplID;
  struct XLUoutputDef *next;
} *XLUoutputDef;

typedef struct XLUactionList
{
  XLUactionType type;
  XLUwindowMode mode;

  XtPointer param;
  String name;
  
  XLUoutputDef outputs;
  struct XLUactionList *next;
} *XLUactionList;

#define actlist_alloc() (XLUactionList) XtNew(struct XLUactionList)
#define NULLActionList (XLUactionList) NULL

typedef struct XLUobjectAction
{
  String action_name;
  XLUactionList to_do;
} *XLUobjectAction;

#define objaction_alloc() (XLUobjectAction) XtNew(struct XLUobjectAction)
#define NULLAction (XLUobjectAction) NULL

/***************************************************
 *
 * Global functions.
 *
 */

void XLUsaveContextData();
Widget XLUfindOutputObject();
BOOLEAN XLUgetOutputTemplateID();
void doPrimitiveSensitivity();
int getActionByName();

#endif /* _Xlu_actions_h_ */

