#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/callbacks.c,v 1.1 94/02/01 16:37:13 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header */

/*****************************************************************************

  callbacks.c - Handle actions defined in xlurc.

*****************************************************************************/

#include "defs.h"

#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/List.h>

#include "query.h"
#include "windows.h"
#include "widgets.h"
#include "objects.h"
#include "requests.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "select.h"

#include "showlist.h"
#include "showentry.h"
#include "update1.h"
#include "formsrch.h"
#include "name.h"
#include "status.h"
#include "errview.h"
#include "browse.h"
#include "pipeout.h"
#include "xdutil.h"
#include "xutil.h"

/***************************************************
 *
 * Local functions.
 *
 */

static void doQuitAction();
static void doCloseAction();
static void doKeepAction();
static void doActivateAction();

/***************************************************
 *
 * Externals.
 *
 */

extern XLUobjectAction actions[];
extern int action_number; 
extern Display *dpy;
extern Atom wm_delete_window;

void exit();
long strtol();

/*****************************************************************************
 * callActionAsCallback()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void callActionAsCallback(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  callAction(w, ActionUndefined);
} /* callActionAsCallback */

/*****************************************************************************
 * callActionAsAction()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void callActionAsAction(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int num_params;
{
  if (params == (String *) NULL)
    {
      callAction(w, ActionUndefined);
    }
  else
    {
      callAction(w, getActionByName(*params));
    }
} /* callActionAsAction */

/*****************************************************************************
 * callAction()
 *
 * 
 *
 ****************************************************************************/

void callAction(w, actid)
     Widget w;
     int actid;
{
  int objid, primid;
  XLUactionList actlist;
  XLUlayoutObject this_template;
  Widget prim_toplevel;
  XLUobjectAction this_action;

  if (actid == ActionUndefined)
    {
      actid = XLUgetPrimitiveActionID(w);
    }

  objid = XLUgetWindowObjectId(w);
  primid = XLUgetPrimitiveType(w);

  switch (primid)
    {
    case MOVETO:
    case ENTRY_LIST:
    case LOOKUP:
    case SEARCH_LOG:
      prim_toplevel = XtParent(w);
      break;

    case ENTRY_DISPLAY:
      prim_toplevel = XtParent(XtParent(XtParent(w)));
      break;

    default:
      prim_toplevel = w;
    }

  /* Verify template and actid */
  this_template = XLUgetPrimitiveTemplate(objid, primid, prim_toplevel);
  
  if (this_template == NULLLayout)
    {
      XLUstatusMessage(objid,
		      "Internal problem! Cannot perform required function!\n");
      return;
    }

  if (IsActionUndefined(actid))
    {
      XLUstatusMessage(objid, "Action undefined!\n");
      return;
    }

  this_action = actions[actid];
  if (this_action == NULLAction)
    {
      XLUstatusMessage(objid, "Action undefined!\n");
      return;
    }

  actlist = this_action->to_do;

  callActionAux(w, objid, primid, actid, actlist);
} /* callAction */

/*****************************************************************************
 * callActionAux()
 *
 * 
 *
 ****************************************************************************/

void callActionAux(pw, objid, primid, actid, actlist)
     Widget pw;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  Widget workwidget;
  XLUactionList curr_trans;
  int output_id, count, stridx, tmpl_id;
  XLUwindowObject this_object;
  entryList current_list;
  Arg args[MAXARGS];
  String strdn, liststr;

  this_object = XLUgetWindowObject(objid);
  doPrimitiveSensitivity(objid);

  if (pw != NULLWidget)
    {
      switch (primid)
	{
	case BUTTON:
	  
	  /* Buttons are insensitive while work is being done */
	  XtSetSensitive(pw, FALSE);
	  break;
	  
	case ENTRY_LIST:

	  /* Get list widget contained in ScrolledWindow */
	  XtSetArg(args[0], XmNworkWindow, &workwidget);
	  XtGetValues(pw, args, 1);
	  
	  /**************************************************
	   *
	   * Set current entry to be selected list
	   * string.
	   * 
	   */

	  liststr = XLUgetListString(pw, &stridx);
	  if (liststr == NULLString)
	    break;

	  XtFree(liststr);

	  for (count = 0, current_list = this_object->current_list;
	       count < stridx;
	       count++, current_list = current_list->next)
	    ;

	  if (current_list != NULLEntryList)
	    {
	      XLUsetWindowEntry(objid, current_list);
	      doPrimitiveSensitivity(objid);
	    }

	  break;
	  
	default:
	  break;
	}
    }

  for (curr_trans = actlist;
       curr_trans != NULLActionList;
       curr_trans = curr_trans->next)
    {
      switch (primid)
	{
	case ENTRY_LIST:
	case MOVETO:
	case LOOKUP:
	case BUTTON:
	case ENTRY_DISPLAY:
	case SEARCH_LOG:

	  switch (curr_trans->type)
	    {
	    case AT_CloseObject:
	      
	      /* Close source window. */
	      doCloseAction(objid, actid, pw);
	      break;

	    case AT_KeepObject:
	      
	      /* Mark source window as kept. */
	      doKeepAction(objid, actid, pw);
	      break;

	    case AT_QuitApp:
	      doQuitAction(objid, actid, pw);
	      break;
	      
	    case AT_RaiseObject:

	      /**************************************************
	       *
	       * Raise or create an output window
	       * and set it's current attributes to those
	       * of the source window.
	       * 
	       */

	      (void) XLUgetOutputTemplateID(curr_trans->outputs,
					    XLUraise,
					    &tmpl_id);

	      (void) XLUfindOutputObject(objid,
					 tmpl_id,
					 curr_trans->mode,
					 &output_id);

	      if (output_id != objid)
		{
		  XLUsetWindowErrors(output_id, this_object->current_errors);
		  XLUsetWindowList(output_id, this_object->current_list);
		  XLUsetWindowEntry(output_id, this_object->current_entry);
		}

	      /* Update displays. */
	      displayCurrentList(output_id);
	      updateErrorViewer(output_id);

	      displayEntryTemplate(NULLWidget,
				   output_id,
				   primid,
				   0,
				   NULLActionList);

	      XLUwait(output_id);
	      
	      displayCurrentEntry(NULLWidget,
				  output_id,
				  primid,
				  0,
				  NULLActionList);

	      doPrimitiveSensitivity(output_id);
	      break;

	    case AT_Activate:

	      /* Activate another primitive. */
	      doActivateAction(pw, objid, primid, actid, curr_trans);
	      doPrimitiveSensitivity(objid);
	      return;

	    case AT_AbortRequest:

	      /* Abort an outstanding directory request. */
	      doAbortRequest(pw, objid, primid, actid, curr_trans);
	      doPrimitiveSensitivity(objid);
	      break;

	    case AT_Pipeout:

	      if (this_object->current_entry != NULLEntryList)
		strdn = this_object->current_entry->string_dn;
	      else
		strdn = "";

	      XLUexternalDataProcess
		(pw, strdn, objid, primid, actid, curr_trans);

	      break;

	    case AT_Select:

	      doSelectAction(pw, objid, primid, actid, curr_trans);
	      break;

	    default:
	      break;
	    }
	}
    }

  /* Return button sensitivity */
  if (primid == BUTTON && pw != NULLWidget)
    XtSetSensitive(pw, TRUE);
} /* callActionAux */

/*****************************************************************************
 * doQuitAction()
 *
 * Quit from XLU.
 *
 ****************************************************************************/

/* ARGSUSED */
static void doQuitAction(objid, actid, w)
     int objid;
     int actid;
     Widget w;
{
  extern Widget toplevel;

  XtUnmapWidget(toplevel);
  XtDestroyWidget(toplevel);

  exit(0);
} /* doQuitAction */

/*****************************************************************************
 * doCloseAction()
 *
 * Close an XLU window object.
 *
 ****************************************************************************/

/* ARGSUSED */
static void doCloseAction(objid, actid, w)
     int objid;
     int actid;
     Widget w;
{
  XLUcloseWindowObject(objid);
} /* doCloseAction */

/*****************************************************************************
 * doKeepAction()
 *
 * Flag a window as having non-eraseable data. This means that the
 * data displayed will be preserved and not normally overwritten.
 *
 ****************************************************************************/

/* ARGSUSED */
static void doKeepAction(objid, actid, w)
     int objid;
     int actid;
     Widget w;
{
  XLUwindowObject object = XLUgetWindowObject(objid);
  object->is_kept = TRUE;
} /* doKeepAction */

/*****************************************************************************
 * XLUwmEvent()
 *
 * Event translation functions used to process window manager events.
 *
 ****************************************************************************/

/* ARGSUSED */
void XLUwmEvent(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     int num_params;
{
  int objid;
  extern Atom wm_delete_window;

  objid = XLUgetWindowObjectId(w);

  if (event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_delete_window)
	{
	  XLUcloseWindowObject(objid);
	}
    }
} /* XLUwmEvent */

/*****************************************************************************
 * doActivatAction()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void doActivateAction(pw,
			     objid,
			     primid,
			     actid,
			     actlist)
     Widget pw;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  Widget *instances;
  int to_activate_id = (int) actlist->param;
  
  switch (to_activate_id)
    {
    case BROWSE:

      if (IsActionUndefined(actid))
	{
	  xluWarning("User action undefined!\n");
	  return;
	}

      doBrowseAction(pw,
		     objid,
		     primid,
		     actid,
		     actlist);
      
      return;

    case ADD:

      if (IsActionUndefined(actid))
	{
	  xluWarning("User action undefined!\n");
	  return;
	}

      doAddAction(pw, objid, primid, actid, actlist);
      return;

    case ENTRY_DISPLAY:

      instances = XLUgetPrimitiveList(objid, ENTRY_DISPLAY);
      if (instances == (Widget *) NULL)
	callActionAux(pw, objid, primid, actid, actlist->next);
      else
	{
          if (IsActionUndefined(actid))
            {
              xluWarning("User action undefined!\n");
	      XtFree((char *) instances);

              return;
            }

          if (lexequ("seealso", actlist->name) == 0)
            doSeeAlsoAction(pw, objid, primid, actid, actlist);
	  
	  XtFree((char *) instances);
        }

      return;

    case LOOKUP:

      instances = XLUgetPrimitiveList(objid, LOOKUP);
      if (instances == (Widget *) NULL)
	  callActionAux(pw, objid, primid, actid, actlist->next);
      else
	{
	  if (IsActionUndefined(actid))
	    {
	      xluWarning("User action undefined!");
	      XtFree((char *) instances);

	      return;
	    }

	  doLookupAction(instances[0], objid, primid, actid, actlist);
	  XtFree((char *) instances);
	}
      
      return;

    case MODIFY:

      instances = XLUgetPrimitiveList(objid, MODIFY);
      if (instances == (Widget *) NULL)
	callActionAux(pw, objid, primid, actid, actlist->next);
      else
	{
	  if (IsActionUndefined(actid))
	    {
	      xluWarning("User action undefined!");
	      XtFree((char *) instances);

	      return;
	    }

	  doModifyAction(instances[0], objid, primid, actid, actlist);
	  XtFree((char *) instances);
	}

      return;

    case MOVETO:

      instances = XLUgetPrimitiveList(objid, MOVETO);
      if (instances == (Widget *) NULL)
	  callActionAux(pw, objid, primid, actid, actlist->next);
      else
	{
	  if (IsActionUndefined(actid))
	    {
	      xluWarning("User action undefined!");
	      XtFree((char *) instances);

	      return;
	    }

	  doMovetoAction(instances[0], objid, primid, actid, actlist);
	  XtFree((char *) instances);
	}

      return;
    }
} /* doActivateAction */

/*****************************************************************************
 * doAbortRequest()
 *
 * 
 *
 ****************************************************************************/

void doAbortRequest(pw, objid, primid, actid, actlist)
     Widget pw;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  XLUrequestRecord rec;
  extern XLUrequestRecord XLUrequestList;

  for (rec = XLUrequestList; rec != NULLXLUrequestRecord; rec = rec->next)
    /***************************************************
     *
     * Find the ids of request issued from this
     * object and abort them.
     *
     */
    if (rec->objid == objid)
      {
	QyAbortRequest(rec->reqid);
	XLUrequestComplete(rec->reqid);
	XLUstatusMessage(objid, "Request aborted!");
      }

  callActionAux(pw,
		objid,
		primid,
		actid,
		actlist == NULLActionList ? actlist: actlist->next);
} /* doAbortRequest */

/*****************************************************************************
 * FreePrimInfo()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void FreePrimInfo(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  primInfo prim_data = (primInfo) closure;

  XtFree((char *) prim_data);
} /* FreePrimInfo */

