/******************************************************************************

  defs.h - Miscellaneous definitions.

******************************************************************************/

#ifndef _Xlu_defs_h
#define _Xlu_defs_h

#define _NO_PROTO

#include <stdio.h>
#include <ctype.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include "types.h"

#ifndef NULLString
#define NULLString (String) NULL
#endif NULLString

typedef enum {USER_FILE, SYSTEM_FILE, SOURCE_FILE} file_org;

#define isemptystr(s) 	((s == NULL || *(s) == '\0'))

#define STRINGLEN 255
#define LINESIZE 1024

typedef enum {horizontal, vertical} orientation;
typedef enum {REF_primitive, REF_layout} ReferenceType;

#define ActionUndefined -1
#define IsActionUndefined(a) (a == -1)

typedef enum
{
  CurrentWin,
  NewAlways,
  NewWhenNone,
  NewWhenKeptGlobal,
  NewWhenKeptLocal
} XLUwindowMode;

typedef enum
{
  AT_One,
  AT_Many,
  AT_RaiseObject,
  AT_CloseObject,
  AT_KeepObject,
  AT_EntrySelect,
  AT_Activate,
  AT_ActivateAndTransfer,
  AT_QuitApp,
  AT_AbortRequest,
  AT_Pipeout,
  AT_Select,
  AT_ClearEntry,
  AT_Undefined
} XLUactionType;

#endif /* _Xlu_defs_h */

