#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/formsrch.c,v 1.1 94/02/01 16:37:25 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/formsrch.c,v 1.1 94/02/01 16:37:25 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  formsrch.c - Form based search

*****************************************************************************/

#include "defs.h"

#include <X11/Xatom.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/Label.h>

#include "quipu/common.h"

#include "windows.h"
#include "widgets.h"
#include "objects.h"
#include "layout.h"
#include "actions.h"
#include "callbacks.h"

#include "requests.h"
#include "configure.h"
#include "y.tab.h"

#include "xdutil.h"
#include "formsrch.h"
#include "xutil.h"

#include "errview.h"
#include "status.h"
#include "showentry.h"
#include "showlist.h"
#include "searchlog.h"

/**************************************************
 *
 * Externals...
 * 
 */

extern Display *dpy;

extern XLUobjectAction actions[];
extern int action_number;

extern QyTargetClass target_classes[];
extern int target_class_num;

/***************************************************
 *
 *	Global data
 *
 */

String default_target = NULLString;

/**************************************************
 *
 * Local data and definitions..
 * 
 */

/* Specify form field position */
typedef enum {FIELDfirst, FIELDmiddle, FIELDlast} FIELDpos;

/* Structure used to save data with text fields */
typedef struct FIELDdata
{
  QySearchClass sclass;
  QyFilter filter;
} *FIELDdata;

/***************************************************
 *
 *	Local functions..
 *
 */

static Widget AddFormField();
static void FieldDestroyCallback();
static void ShowCursor();

/*****************************************************************************
 * SearchForType()
 *
 * 
 *
 ****************************************************************************/

void SearchForType(menu_entry, new_edits)
     Widget menu_entry;
     Widget new_edits[];
{
  QyTargetClass target;
  QySearchClass srchclass;
  stringCell classname;
  QyFilter filter;
  Widget type_menu,
         last_label,
         last_dialog,
         first_dialog,
	 form, from;
  Widget wlist[64];
  Arg args[MAXARGS];
  int count, wcount, dialognum;
  int type_index;
  XmString cstring, labelstr;
  String type_label;
  FIELDpos fieldpos;
  
  form = XtParent(XtParent(XtParent(menu_entry)));
  
  XtSetArg(args[0], XmNlabelString, &cstring);
  XtGetValues(menu_entry, args, 1);

  type_label = XLUgetXmStringText(cstring);

  for (type_index = 0, target = target_classes[type_index];
       type_index < target_class_num &&
       lexequ(target->label, type_label) != 0;
       type_index++, target = target_classes[type_index])
    ;

  XtFree(type_label);

  if (type_index == target_class_num)
    return;

  type_menu = XtNameToWidget(form, "typeButton");
  if (type_menu == NULLWidget)
    return;

  XtSetArg(args[0], XmNresizable, FALSE);
  XtSetValues(form, args, 1);

  /***************************************************
   *
   *	Freeze updates to form
   *
   */

  first_dialog = XtNameToWidget(form, "firstTypeDialog");
  last_dialog = XtNameToWidget(form, "lastTypeDialog");

  /***************************************************
   *
   *	Get all dialogs
   *
   */

  XtSetArg(args[0], XmNtopWidget, &last_dialog);

  wcount = 0;
  
  if (first_dialog != NULLWidget)
    wlist[wcount++] = first_dialog;

  if (last_dialog != NULLWidget)
    {
      do
	{
	  wlist[wcount++] = last_dialog;
	  XtGetValues(last_dialog, args, 1);
	}
      while (last_dialog != first_dialog && first_dialog != NULLWidget);

      /* Get topmost label */
      XtGetValues(last_dialog, args, 1);
      wlist[wcount++] = last_dialog;

      /***************************************************
       *
       *    Get all labels and tick boxes
       *
       */

      for (count = 1, dialognum = wcount; count < dialognum; count++)
	{
	  if (lexequ(XtName(wlist[count]), "typeGroupLabel") != 0)
	    {
	      XtSetArg(args[0], XmNleftWidget, &last_label);
	      XtGetValues(wlist[count], args, 1);
	      wlist[wcount++] = last_label;
	    }
	}
    }

  if (first_dialog != NULLWidget)
    {
      XtSetArg(args[0], XmNleftWidget, &last_label);
      XtGetValues(wlist[0], args, 1);
      
      wlist[wcount++] = last_label;
    }
      
  XtUnmanageChildren(wlist, wcount);
  
  for (count = 0; count < wcount; count++)
    {
      XmRemoveTabGroup(wlist[count]);
      XtDestroyWidget(wlist[count]);
    }

  XFlush (dpy);
  
  /**************************************************
   *
   * Create target fields
   * 
   */
  
  wcount = 0;
  from = type_menu;
  fieldpos = FIELDfirst;

  labelstr = XmStringCreateSimple(target->label);

  count = 0;
  XtSetArg(args[count], XmNlabelString, labelstr); count++;
  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;
  XtSetArg(args[count], XmNtopWidget, from); count++;
  
  last_label = XmCreateLabel(form, "typeGroupLabel", args, count);

  XmStringFree(labelstr);
  XtManageChild(last_label);

  from = last_label;
  srchclass = QyString2SearchClass(target->label);
  for (filter = srchclass->filter;
       filter != (QyFilter) NULL;
       filter = filter->andchain)
    {
      if (filter == srchclass->filter)
	fieldpos = FIELDfirst;
      else if (target->context_classes == NULLStrCell)
	{
	  fieldpos =
	    (filter->andchain == (QyFilter) NULL? FIELDlast : FIELDmiddle);
	}
      else
	fieldpos = FIELDmiddle;

      from = AddFormField(form, srchclass, filter, from, fieldpos);
      wlist[wcount++] = from;
    }

  /**************************************************
   *
   * Create context fields
   * 
   */

  for (classname = target->context_classes;
       classname != NULLStrCell;
       classname = classname->next)
    {
      srchclass = QyString2SearchClass(classname->string);
      labelstr = XmStringCreateSimple(srchclass->label);
      
      count = 0;
      XtSetArg(args[count], XmNlabelString, labelstr); count++;
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
      XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;
      XtSetArg(args[count], XmNtopWidget, from); count++;
      
      last_label = XmCreateLabel(form, "typeGroupLabel", args, count);
      
      XmStringFree(labelstr);
      XtManageChild(last_label);

      from = last_label;
      for (filter = srchclass->filter;
	   filter != (QyFilter) NULL;
	   filter = filter->andchain)
	{
	  if (classname->next == NULLStrCell)
	    {
	      fieldpos =
		(filter->andchain == (QyFilter) NULL? FIELDlast : FIELDmiddle);
	    }
	  else
	    fieldpos = FIELDmiddle;
	  
	  from = AddFormField(form, srchclass, filter, from, fieldpos);
	  wlist[wcount++] = from;
	}
    }

  /**************************************************
   *
   * Copy new widgets.
   * 
   */

  if (new_edits != (WidgetList) NULL)
    {
      for (count = 0; count < wcount; count++)
	new_edits[count] = wlist[count];

      new_edits[count] = NULLWidget;
    }
} /* SearchForType */

/*****************************************************************************
 * AddFormField()
 *
 * Create a text edit field in a form search dialog.
 * Save context pointers to associated search class and filter.
 * Created field is vertically offset from Widget \'from\'.
 *
 ****************************************************************************/

static Widget AddFormField(form, sclass, filter, from, pos)
     Widget form;
     QySearchClass sclass;
     QyFilter filter;
     Widget from;
     FIELDpos pos;
{
  Arg args[MAXARGS];
  int count;
  XmString labelstr;
  String fieldname;
  Widget label, field;
/*
  Dimension form_width,
            label_width,
            label_border_width,
	    dialog_border_width;
  int dialog_width;
*/
  FIELDdata fldata;

  /**************************************************
   *
   * Create field label.
   * 
   */

  labelstr = XmStringCreateSimple(filter->label);

  count = 0;

  XtSetArg(args[count], XmNlabelString, labelstr); count++;
  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;

  XtSetArg(args[count], XmNleftAttachment, XmATTACH_FORM); count++;
  XtSetArg(args[count], XmNtopWidget, from); count++;

  XtSetArg(args[count], XmNleftOffset, 20); count++;
  label = XmCreateLabel(form, "typeLabel", args, count);

  XmStringFree(labelstr);
  XtManageChild(label);

  /**************************************************
   *
   * Create edit field
   * 
   */

  switch (pos)
    {
    case FIELDfirst:
      fieldname = "firstTypeDialog";
      break;

    case FIELDmiddle:
      fieldname = "typeDialog";
      break;

    case FIELDlast:
      fieldname = "lastTypeDialog";
      break;
    }

  count = 0;
  
  XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;
  
  XtSetArg(args[count], XmNtopWidget, from); count++;
  XtSetArg(args[count], XmNleftWidget, label); count++;
  
  XtSetArg(args[count], XmNresizable, TRUE); count++;
  XtSetArg(args[count], XmNcursorPositionVisible, FALSE); count++;

  field = XmCreateTextField(form, fieldname, args, count);

  XmAddTabGroup(field);
  XtManageChild(field);

  XtAddCallback(field, XmNfocusCallback, ShowCursor, (XtPointer) TRUE);
  XtAddCallback(field, XmNlosingFocusCallback, ShowCursor, (XtPointer) FALSE);

  /* Save search class and filter spec pointers */
  fldata = (FIELDdata) XtNew(struct FIELDdata);
  fldata->sclass = sclass;
  fldata->filter = filter;

  XLUsavePrimitiveContext(field, LOOKUP, ActionUndefined);
  XLUsavePrimitiveData(field, (XtPointer) fldata, FieldDestroyCallback);

  return field;
} /* AddFormField */

/*****************************************************************************
 * FieldDestroyCallback()
 *
 * Clean up callback for form fields.
 *
 ****************************************************************************/

/* ARGSUSED */
static void FieldDestroyCallback(field, userdata, calldata)
     Widget field;
     XtPointer userdata;
     XtPointer calldata;
{
  Arg args[MAXARGS];
  XtPointer ptr;

  XtSetArg(args[0], XmNuserData, &ptr);
  XtGetValues(field, args, 1);
  XtFree(ptr);
} /* FieldDestroyCallback */

/*****************************************************************************
 * ChangeSearchType()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void ChangeSearchType(this_widget, closure, calldata)
     Widget this_widget;
     XtPointer closure;
     XtPointer calldata;
{
  Widget active, new_edits[64];
  WidgetList instances;
  int objid, count;
  int actid;

  SearchForType(this_widget, new_edits);
  XtRealizeWidget(XtParent(XtParent(XtParent(this_widget))));

  XFlush(dpy);

  objid = XLUgetWindowObjectId(this_widget);
  instances = XLUgetPrimitiveList(objid, LOOKUP);
  
  actid = XLUgetPrimitiveActionID(instances[0]);
  XtFree((char *) instances);

  /* Save context data for each form field */
  for (count = 0; new_edits[count] != NULLWidget; count++)
    {
      active = new_edits[count];
      XLUsavePrimitiveContext(active, LOOKUP, actid);
    }
} /* ChangeSearchType */

/*****************************************************************************
 * doLookupAction()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void doLookupAction(prim_widget,
		    objid,
		    primid,
		    actid,
		    actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  Widget topfield, field, form;
  Widget *instances;
  Arg args[MAXARGS];
  int logid;
  struct _QyFormService srchsvc;
  QyFormData target_data = NULLSearchData,
             context_data = NULLSearchData,
  curr_data = NULLSearchData;
  QySearchClass sclass, currclass, target;
  QyFilter filter;
  QyFilterData filtdata, newdata;
  FIELDdata fldata;
  int reqid;
  String value;
  stringCell select;
  QyErrorList errors;
  XtPointer ptr;
  XLUoutputDef output;
  XLUwindowObject winobj;
  entryList baseobjs;
  
  extern char *TidyString();

  instances = XLUgetPrimitiveList(objid, LOOKUP);
  if (instances == (Widget *) NULL)
    {
      callActionAux(prim_widget,
		  objid,
		  primid,
		  actid,
		  actlist->next);
      return;
    }

  form = instances[0];
  winobj = XLUgetWindowObject(objid);

  XtFree(instances);

  /**************************************************
   *
   * Get target class.
   * 
   */

  topfield = XtNameToWidget(form, "firstTypeDialog");
  ptr = XLUgetPrimitiveData(topfield);
  
  fldata = (FIELDdata) ptr;
  target = fldata->sclass;
  
  /**************************************************
   *
   * Get context search data.
   * 
   */

  field = XtNameToWidget(form, "lastTypeDialog");
  ptr = XLUgetPrimitiveData(field);

  fldata = (FIELDdata) ptr;
  sclass = fldata->sclass;
  
  while (sclass != target)
    {
      currclass = sclass;

      curr_data = search_data_alloc();
      curr_data->class = sclass;

      curr_data->next = (QyFormData) NULL;
      curr_data->filtdata = (QyFilterData) NULL;

      curr_data->task_list = (QyDSTaskRecord) NULL;
      filtdata = (QyFilterData) NULL;

      while (currclass == sclass)
	{
	  /* Get filter */
	  filter = fldata->filter;
	  
	  /* Get search string */
	  XtSetArg(args[0], XmNvalue, &value);
	  XtGetValues(field, args, 1);
	  
	  /* Create new search data structure */
	  value = TidyString(value);
	  if (value != NULLString && *value != '\0')
	    {
	      newdata = (QyFilterData) XtNew(struct QyFilterData);
	      newdata->next = filtdata;
	      
	      filtdata = newdata;
	      newdata->filter = filter;
	      
	      newdata->values = NULLStrCell;
	      SeqAddString(value, &newdata->values);
	    }

	  /* Loop through fields associated with current context class */
	  do
	    {
	      XtSetArg(args[0], XmNtopWidget, &field);
	      XtGetValues(field, args, 1);
	    }
	  while (lexequ(XtName(field), "typeGroupLabel") == 0);

	  ptr = XLUgetPrimitiveData(field);
	  
	  fldata = (FIELDdata) ptr;
	  sclass = fldata->sclass;
	}

      if (filtdata != (QyFilterData) NULL)
	{
	  curr_data->next = context_data;
	  curr_data->filtdata = filtdata;
	  context_data = curr_data;
	}
      else
	XtFree((char *) curr_data);
    }

  /**************************************************
   *
   * Extract target search data.
   * 
   */

  curr_data = search_data_alloc();
  curr_data->class = sclass;
  curr_data->next = (QyFormData) NULL;
  curr_data->filtdata = (QyFilterData) NULL;
  filtdata = (QyFilterData) NULL;

  do
    {
      /* Get search class */
      ptr = XLUgetPrimitiveData(field);

      fldata = (FIELDdata) ptr;
      sclass = fldata->sclass;

      /* Get filter */
      filter = fldata->filter;
    
      /* Get search string */
      XtSetArg(args[0], XmNvalue, &value);
      XtGetValues(field, args, 1);

      /* Create new search data structure */
      value = TidyString(value);
      if (value != NULLString && *value != '\0')
	{
	  newdata = (QyFilterData) XtNew(struct QyFilterData);
	  newdata->next = filtdata;
	  
	  filtdata = newdata;
	  newdata->filter = filter;
	  
	  newdata->values = NULLStrCell;
	  SeqAddString(value, &newdata->values);
	}
      else
	newdata = (QyFilterData) NULL;
	
      /* Loop through fields associated with target class */
      do
	{
	  XtSetArg(args[0], XmNtopWidget, &field);
	  XtGetValues(field, args, 1);
	}
      while (lexequ(XtName(field), "typeGroupLabel") == 0);
    }
  while (lexequ(XtName(field), "typeButton") != 0);

  if (filtdata != (QyFilterData) NULL)
    {
      target_data = curr_data;
      target_data->filtdata = filtdata;
    }
  else
    XtFree((char *) curr_data);
  
  /**************************************************
   *
   * Got search values, now start search.
   * 
   */

  if (target_data == NULLSearchData)
    /* Can\'t search without any target data */
    {
      XLUstatusMessage(objid, "Please enter a target value!");
      XBell(dpy, 40);
      
      if (context_data != NULLSearchData)
	QyFreeFormData(&context_data);
    }
  else
    {
      /* Get attribute selection */ 
      select = GetFullSelection();
      
      baseobjs = winobj->current_entry;
      if (baseobjs == NULLEntryList)
	baseobjs = winobj->current_list;

      /* Set search service flags */
      srchsvc.automatic = TRUE;

      errors = QyFormSearch
	(target_data, context_data, baseobjs, select, &srchsvc, &reqid);

      if (errors != NULLError)
	{
	  switch (errors->error_type)
	    {
	    case QERR_bad_value_syntax:
	      XBell(dpy, 40);
	      XLUstatusMessage(objid, "The search data entered is invalid!");
	      
	      callActionAux(prim_widget, objid, primid, actid, actlist->next);
	      return;
	      
	    case QERR_internal_limit_reached:
	      XBell(dpy, 40);
	      XLUstatusMessage
		(objid, "Internal limit reached, cannot search!");
	      
	      callActionAux(prim_widget, objid, primid, actid, actlist->next);
	      return;
	  
	    case QERR_invalid_search_class:
	      XBell(dpy, 40);
	      XLUstatusMessage
		(objid,"Not enough search informations supplied!");
	      
	      callActionAux(prim_widget, objid, primid, actid, actlist->next);
	      return;
	      
	    default:
	      break;
	    }
	}

      /* Find log window, if supplied. */
      logid = -1;
      for (output = actlist->outputs;
	   output != (XLUoutputDef) NULL;
	   output = output->next)
	{
	  if (output->type == XLUlogTo)
	    {
	      (void) XLUfindOutputObject(objid,
					 output->outputTmplID,
					 actlist->mode,
					 &logid);
	      
	      break;
	    }
	}
      
      /* If a log output window has been found, make it the request owner. */
      if (logid >= 0)
	objid = (int) logid;
      
      /* Record request invocation. */
      XLUstatusMessage(objid, "Searching. Please Wait.");
      XLUrequestInvoked(reqid,
			UFSEARCH,
			gotLookupResults,
			gotLookupReport,
			prim_widget,
			objid,
			primid,
			actid,
			actlist);
      
      /* Log initial report */
      if (logid > 0)
	{
	  LogFormReport(logid, reqid);
	}
    }
} /* doLookupAction */

/*****************************************************************************
 * gotLookupReport()
 *
 * A form search report has been received. Pass it on to the search log
 * window.
 *
 ****************************************************************************/

void gotLookupReport(reqid, objid)
     int reqid;
     int objid;
{
  XLUwindowObject winobj;

  /* Check that the owner window is still on the desktop. */
  winobj = XLUgetWindowObject(objid);
  if (winobj == NULL)
    {
      /* If request owner has gone, abort the request. */
      XLUrequestComplete(reqid);
      QyAbortRequest(reqid);

      return;
    }

  /* Log the report. */
  LogFormReport(objid, reqid);
} /* gotLookupReport */

/*****************************************************************************
 * gotLookupResults()
 *
 * A form lookup result has been received. Process and display errors,
 * results as appropriate.
 *
 ****************************************************************************/

/* ARGSUSED */
void gotLookupResults(reqid, objid, actid, actlist)
     int reqid;
     int objid;
     int actid;
     XLUactionList actlist;
{
  QyFormSearchResult result;
  int match_num;
  QyErrorList curr_error;
  entryList matches;
  int childid, tmplid, err_num;
  char msg[LINESIZE], buf[LINESIZE];
  XLUwindowObject winobj;
  
  result = QyGetFormResult(reqid);

  /* Check that the owner window is still on the desktop. */
  winobj = XLUgetWindowObject(objid);
  if (winobj == NULL)
    {
      QyFreeFormResult(&result);
      return;
    }

  /* Notify user */
  XLUstatusMessage(objid, "Results received");
  XBell(dpy, 40);

  /* Count number of matches */
  for (match_num = 0, matches = result->matches; 
       matches != NULLEntryList;
       match_num++, matches = matches->next)
    ;

  /* Count number of errors */
  for (curr_error = result->errors, err_num = 0;
       curr_error != NULLError;
       curr_error = curr_error->next, err_num++)
    ;

  if (match_num == 0)
    {
      if (err_num <= 1)
	(void) sprintf(msg, "Nothing found using given search values");
      else
	(void) strcpy(msg, "Search failed!");
    }
  else
    {
      if (match_num == 1)
	{
	  (void) XLUgetOutputTemplateID(actlist->outputs, XLUoneHit, &tmplid);
	  (void) XLUfindOutputObject(objid, tmplid, actlist->mode, &childid);
	  
	  (void) strcpy(msg, "Made 1 good match");
	  
	  XLUsetWindowEntry(childid, result->matches);
	  displayCurrentEntry(NULLWidget, childid, 0, 0, NULLActionList);

	  displayCurrentList(childid);
	  doPrimitiveSensitivity(childid);
	}
      else if (match_num > 1)
	{
	  (void) XLUgetOutputTemplateID(actlist->outputs, XLUmanyHits,&tmplid);
	  (void) XLUfindOutputObject(objid, tmplid, actlist->mode, &childid);
	  
	  (void) sprintf(msg, "Made %d good matches", match_num);
	  
	  XLUsetWindowList(childid, result->matches);
	  displayCurrentList(childid);
	  
	  doPrimitiveSensitivity(childid);
	}
    }

  /* Add warning if errors have occured */
  if (err_num > 0)
    {
      (void) sprintf(buf, "\n%d Error(s) Occurred During Search", err_num);
      (void) strcat(msg, buf);
    }

  /* Display status message */
  XLUstatusMessage(objid, msg);
	    
  /* Display errors (if this window contains an error view) */
  XLUsetWindowErrors(objid, result->errors);
  updateErrorViewer(objid);

  /* All done */
  XLUrequestComplete(reqid);
  QyFreeFormResult(&result);
} /* gotLookupResults */

/*****************************************************************************
 * ShowCursor()
 *
 * Turn cursor display in a text field on.
 *
 ****************************************************************************/

static void ShowCursor(w, closure, calldata)
     Widget w;
     XtPointer closure, calldata;
{
  Arg args[MAXARGS];

  XtSetArg(args[0], XmNcursorPositionVisible, (BOOLEAN) closure);
  XtSetValues(w, args, 1);
} /* ShowCursor */

