#ifndef lint
static char *rcsid = "";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/RCS/help_display.c,v 0.97 91/09/05 13:26:01 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  help.c - Display help in the form of text and/or a bitmap

*****************************************************************************/

#include "defs.h"

#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>

#include "query.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "status.h"

#include "help.h"

/***************************************************
 *
 * Externals.
 *
 */

extern char bitmap_directory[];

/***************************************************
 *
 * Global data.
 *
 */

char help_directory[LINESIZE];

/***************************************************
 *
 * Local data.
 *
 */

static char file_path[LINESIZE];

/*****************************************************************************
 * setHelp()
 *
 * 
 *
 ****************************************************************************/

void setHelp(help_widget, template)
     Widget help_widget;
     XLUlayoutObject template;
{
  Widget text_widget;
  String filename;
  Arg args[MAXARGS];
  PS ps;
  FILE *helpfile;
  static char buffer[LINESIZE];
  String help_text;
  int linecount;

  XtSetArg(args[0], XmNworkWindow, &text_widget);
  XtGetValues(help_widget, args, 1);
  
  filename = template->help_file;
  if (isemptystr(filename))
    return;

  ps = ps_alloc(str_open);
  if (ps == NULLPS)
    return;
  
  if (str_setup(ps, NULLCP, 0, 0) == NOTOK)
    {
      ps_free(ps);
	  return;
    }
  
  (void) sprintf(file_path, "%s%s", help_directory, filename);
  
  helpfile = fopen(file_path, "r");
  if (helpfile == (FILE *) NULL)
    {
      char msg[LINESIZE];
      
      (void) sprintf(msg,
		     "Error: Could not open help file `%s'\n",
		     file_path);
      
      XLUpopupMessage(msg);
	  
      ps_free(ps);
      return;
    }
  
  linecount = 0;
  while (fgets(buffer, LINESIZE - 1, helpfile) != NULL)
    {
      ps_printf(ps, "%s", buffer);
      linecount = 1;
    }
  
  help_text = ps->ps_base;
  *ps->ps_ptr = '\0';
  
  XtSetArg(args[0], XmNvalue, help_text);
  XtSetValues(text_widget, args, 1);
  
  XtSetArg(args[0], XmNtopCharacter, 0);
  XtSetArg(args[1], XmNcursorPosition, 0);
  XtSetArg(args[2], XmNrows, linecount);
  XtSetValues(text_widget, args, 3);
  
  ps_free(ps);
  XmTextShowPosition(text_widget, 0);
} /* setHelp */

