#ifndef _Xlu_requests_h_
#define _Xlu_requests_h_

#include "defs.h"
#include "windows.h"
#include "actions.h"
#include "query.h"

typedef void (*DSResultCallback)();
typedef void (*DSReportCallback)();

typedef struct XLUrequestRecord
{
  int reqid;
  QyRequestType type;

  DSResultCallback result_cb;
  DSReportCallback report_cb;

  XtInputId input_id;
  int assoc_desc;

  Widget this_widget;
  int objid;
  int prim_id;

  int action_id;
  XLUactionList actlist;

  struct XLUrequestRecord *next;
} *XLUrequestRecord;

#define xlu_request_record_alloc() (XLUrequestRecord) \
	XtNew(struct XLUrequestRecord)

#define NULLXLUrequestRecord (XLUrequestRecord) NULL

/***************************************************
 *
 * Public functions..
 *
 */

void XLUrequestComplete();
void XLUrequestInvoked();
XLUrequestRecord XLUgetRequest();

#endif /* _Xlu_requests_h_ */
