#ifndef lint
static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/showlist.c,v 1.1 94/02/01 16:38:17 ccsrdsm Exp Locker: ccsrdsm $";
#endif

/* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/showlist.c,v 1.1 94/02/01 16:38:17 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

  showlist.c - Display lists of directory entries

*****************************************************************************/

#include "defs.h"

#include <X11/Xatom.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/List.h>

#include "query.h"
#include "read.h"
#include "quipu/common.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "showlist.h"

/***************************************************
 *
 * Local functions.
 *
 */

static void updateEntryList();

/***************************************************
 *
 * Externals.
 *
 */

/*****************************************************************************
 * displayCurrentList()
 *
 * 
 *
 ****************************************************************************/

void displayCurrentList(objid)
     int objid;
{
  int listsize;
  WidgetList prim_insts;
  XLUwindowObject winobj;
  entryList currlist;

  winobj = XLUgetWindowObject(objid);

  if (winobj->current_list != NULLEntryList)
    {
      for (currlist = winobj->current_list, listsize = 0;
	   currlist != NULLEntryList;
	   currlist = currlist->next, listsize++)
	;
      
      currlist = winobj->current_list;
    }
  else if (winobj->current_entry != NULLEntryList)
    {
      currlist = winobj->current_entry;
      listsize = 1;
    }
  else
    {
      currlist = NULLEntryList;
      listsize = 0;
    }

  prim_insts = XLUgetPrimitiveList(objid, ENTRY_LIST);
  if (prim_insts != (Widget *) NULL)
    {
      updateEntryList(prim_insts[0], objid, listsize, currlist);
      XtFree((char *) prim_insts);
    }
} /* displayCurrentList */

/*****************************************************************************
 * updateEntryList()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void updateEntryList(widget, objid, listsize, entrylist)
     Widget widget;
     int objid;
     int listsize;
     entryList entrylist;
{
  Widget sw, list;
  int dncount;
  Arg args[MAXARGS];
  entryList currdn, listcopy = NULLEntryList;
  char linebuf[LINESIZE], dnbuf[LINESIZE];
  XmString *stringlist, *liststr;
  AttributeType oc_type;
  stringCell strvals, currval;
  XLUlistSelection select;
  BOOLEAN got_it;
  QyAttrValList avlist;

  stringlist = (XmString *)
    XtMalloc((unsigned) (listsize * sizeof(XmString)));

  /***************************************************
   *
   * Copy entry list.
   *
   */

  (void) dn_list_copy(entrylist, &listcopy);
  sw = widget;

  oc_type = str2AttrT("2.5.4.0");
  for (dncount = 0, currdn = listcopy;
       dncount < listsize;
       dncount++, currdn = currdn->next)
    {
      /***************************************************
       *
       * ...and selected attributes.
       *
       * First get list of attributes that should be
       * displayed for entries with this objectClass list.
       *
       */

      for (avlist = currdn->entry; avlist != NULLAVList; avlist = avlist->next)
	if (avlist->attr_name != NULLStrCell)
	  {
	    if (oc_type == str2AttrT(avlist->attr_name->string))
	      {
		select = GetListSelection(avlist->val_list);
		break;
	      }		
	  }

      liststr = &stringlist[dncount];
      if (select == (XLUlistSelection) NULL || select->showdn == TRUE)
	{
	  /* Print RDN of entry... */
	  QyPrintFriendlyDN(currdn->string_dn, dnbuf);
	  *liststr = XmStringCreateSimple(dnbuf);

	  XLUappendXmString
	    (liststr, "                                        ");
	  XLUappendSeparatorXmString(liststr);
	}
      else
	{
	  *liststr = XmStringCreateSimple("");
	}

      if (select == (XLUlistSelection) NULL)
	{
	  strvals = NULLStrCell;
	}
      else
	{
	  /* Only display attributes in the select list */
	  strvals = XLUgetListValues(currdn->entry, select->listvals);
	}

      currval = strvals;
      while (currval != NULLStrCell)
	{
	  linebuf[0] = '\0';
	  for (;
	       currval != NULLStrCell && *currval->string != '\n';
	       currval = currval->next)
	    {
	      if (*linebuf != '\0')
		(void) strcat(linebuf, ", ");
	      else
		(void) strcat(linebuf, "  ");

	      (void) strcat(linebuf, currval->string);
	    }

	  XLUappendXmString(liststr, linebuf);
	  XLUappendXmString
	    (liststr, "                                        ");

	  if (currval != NULLStrCell && *currval->string == '\n')
	    {
	      if (currval != strvals)
		XLUappendSeparatorXmString(liststr);

	      currval = currval->next;
	    }
	}

      SeqFree(&strvals);
    }

  /* Get the list widget, clear current list and add new one */
  XtSetArg(args[0], XmNworkWindow, &list);
  XtGetValues(sw, args, 1);

  XmListDeleteAllItems(list);
  XmListAddItems(list, stringlist, (int) listsize, 1);

  /* All done */
  for (dncount = 0; dncount < listsize; dncount++)
    XmStringFree(stringlist[dncount]);

  XtFree((XtPointer) stringlist);
  dn_list_free(&listcopy);
} /* updateEntryList */

/*****************************************************************************
 * selectListEntry()
 *
 * Set the newly selected entry as the current entry for this window.
 *
 ****************************************************************************/

void selectListEntry(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Arg args[MAXARGS];
  Widget workwidget;
  int stridx, objid, count;
  entryList currdn;
  XLUwindowObject winobj;
  String liststr;

  /* Get list widget contained in ScrolledWindow */
  XtSetArg(args[0], XmNworkWindow, &workwidget);
  XtGetValues(w, args, 1);

  objid = XLUgetWindowObjectId(w);
  winobj = XLUgetWindowObject(objid);
	  
  /**************************************************
   *
   * Set current entry to be selected list
   * string.
   * 
   */

  liststr = XLUgetListString(w, &stridx);
  if (liststr == NULLString)
    return;

  XtFree(liststr);
  
  for (count = 0, currdn = winobj->current_list;
       count < stridx;
       count++, currdn = currdn->next)
    ;

  if (currdn != NULLEntryList)
    XLUsetWindowEntry(objid, currdn);

  doPrimitiveSensitivity(objid);
} /* selectListEntry */

