#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <Xm/SelectioB.h>

Widget toplevel;
XtAppContext app_context;
Display *dpy;
char *resource_class = "strget", *program_name = "strget";

static void DialogOk();
static char *GetXmStringText();

int main(argc, argv)
     int argc;
     char *argv[];
{
  Widget dlg, button;
  int count;
  Arg args[16];
  char *filename;
  char path[1024], name[1024];
  XmString filestr, label;
  XmString table[2];

  extern char *rindex();

  if (argc < 2)
    return 0;

  (void) strcpy(name, argv[1]);
  filename = rindex(name, '/');
  
  if (filename != (char *) NULL)
    *filename++ = '\0';
  else
    filename = argv[1];

  (void) strcpy(name, filename);

  toplevel = XtAppInitialize(&app_context,
                             resource_class, 
                             NULL,
                             0,
                             &argc, argv,
                             NULL,
                             NULL,
                             0);

  dpy = XtDisplay(toplevel);

  filestr = XmStringCreateSimple(filename);
  table[1] = XmStringCreateSimple(filename);
  label = XmStringCreateSimple("Please enter local file name");

  count = 0;

  XtSetArg(args[count], XmNtextString, filestr); count++;
  XtSetArg(args[count], XmNselectionLabelString, label); count++;

  XtSetArg(args[count], XmNlistItems, table); count++;
  XtSetArg(args[count], XmNlistItemCount, 1); count++;

  XtSetArg(args[count], XmNwidth, 300); count++;
  XtSetArg(args[count], XmNheight, 300); count++;

  dlg = XmCreatePromptDialog(toplevel, "Filename", args, count);
  XtAddCallback(dlg, XmNokCallback, DialogOk, (XtPointer) NULL);

  XmStringFree(label);
  XmStringFree(filestr);
  XmStringFree(table[0]);

  /* Destroy buttons we don\'t want */
  button = XmSelectionBoxGetChild(dlg, XmDIALOG_HELP_BUTTON);
  XtUnmanageChild(button);

  button = XmSelectionBoxGetChild(dlg, XmDIALOG_CANCEL_BUTTON);
  XtUnmanageChild(button);

  XtManageChild(dlg);
  XtPopup(XtParent(dlg), XtGrabNone);

  XtAppMainLoop(app_context);
  return 0;
} /* main */

static void DialogOk(w, closure, calldata)
  Widget w;
  XtPointer closure, calldata;
{
  XmString filestr;
  int count;
  Arg args[16];
  char *filename;

  XtSetArg(args[0], XmNtextString, &filestr);
  XtGetValues(w, args, 1);
  
  filename = GetXmStringText(filestr);
  fprintf(stdout, "%s", filename);

  XtUnmanageChild(w);
  XtDestroyWidget(toplevel);

  exit(0);
} /* DialogOk */

static char *GetXmStringText(cstring)
     XmString cstring;
{
  XmStringContext strctx;
  char * str;
  XmStringCharSet chset;
  XmStringDirection direction;
  XmStringComponentType comptype, utype;
  unsigned short ulen;
  unsigned char uchar;
 
  (void) XmStringInitContext(&strctx, cstring);
  
  do
    {
      comptype = XmStringGetNextComponent(strctx,
                                          &str,
                                          &chset,
                                          &direction,
                                          &utype,
                                          &ulen,
                                          &uchar);
    }
  while (comptype != XmSTRING_COMPONENT_END);
 
  XmStringFreeContext(strctx);
  return str;
} /* XLUgetXmStringText */





