#ifndef lint
 static char *rcsid = "$Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/update1.c,v 1.1 94/02/01 16:37:49 ccsrdsm Exp Locker: ccsrdsm $";
#endif
 /* $Header: /a/izar/vol/fileservers/izar/izar4/src/local/X500/xd/work.motif/src/RCS/update1.c,v 1.1 94/02/01 16:37:49 ccsrdsm Exp Locker: ccsrdsm $ */

/*****************************************************************************

   update1.c - Handles user interface to update, add and delete

*****************************************************************************/

#include "defs.h"
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/MenuShell.h>
#include <Xm/RowColumn.h>
#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "ask.h"

#include "update1.h"
#include "update2.h"
#include "status.h"
#include "errview.h"

/***************************************************
 *
 * Externals.
 *
 */

extern char bitmap_directory[];
extern Display *dpy;

extern Widget toplevel;
extern XLUentryClass entry_class_list;
extern XLUattributeGroup attr_group_list;
extern XLUattrTemplate attr_template_list;

/***************************************************
 *
 * Local storage.
 *
 */

static char err_msg[LINESIZE];

#define AttributeDefaultDistance 10
#define MenuDimension 12

/***************************************************
 *
 * Callback record for modify edit widgets.
 *
 */

static void modifyFieldUpdate(), modifyFieldDestroyed();

XtCallbackRec modCallback[] =
{
  {modifyFieldUpdate, (XtPointer) NULL},
  {(XtCallbackProc) NULL, (XtPointer) NULL},
};

/**************************************************
 *
 * Global functions.
 * 
 */

/* Clean up after the modify form widget is destroyed */
void modifyDestroyCleanup();
void updateFieldData();

/***************************************************
 *
 * Local functions.
 *
 */

static modifyField newModifyField();
static void displaySelectedGroup();

static void displayGroup();
static Widget displayGroupAttribute();

static void freeModifyState();
static void freeModifyEntry();
static void selectClass();

static void addValue();
static void deleteValue();
static void undoChanges();
static void undoAllChanges();

static Widget createValueEdit();

/*****************************************************************************
 * doModifyAction()
 *
 * Currently performs a "commit" operation on outstanding changes.
 *
 ****************************************************************************/

void doModifyAction(pw, objid, primid, actid, actlist)
     Widget pw;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  if (lexequ(actlist->name, "Save") == 0)
    /* Save current changes */
    {
      submitModifications(pw);
    }
} /* doModifyAction */

/*****************************************************************************
 * initModifyStateData()
 *
 * Initialize state context for a modify primitive.
 *
 ****************************************************************************/

void initModifyStateData(pw)
     Widget pw;
{
  XLUupdateContext state = update_state_alloc();

  state->state = NoEntry;
  state->changes = FALSE;
  state->name = NULLString;
  state->class = NULLEntryClass;
  state->modentry = NULLModifyEntry;

  XLUsavePrimitiveData(pw, (XtPointer) state, freeModifyState);
} /* initModifyStateData */

/*****************************************************************************
 * freeModifyState()
 *
 * Free XLUupdateContext structure.
 *
 ****************************************************************************/

static void freeModifyState(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  XLUupdateContext modstate;

  modstate = (XLUupdateContext) closure;
  if (modstate == (XLUupdateContext) NULL)
    return;

  if (modstate->name != NULLString)
    XtFree(modstate->name);

  if (modstate->modentry != NULLModifyEntry)
    freeModifyEntry(modstate->modentry);

  XtFree((char *) modstate);
} /* freeModifyState */

/*****************************************************************************
 * displayEntryTemplate()
 *
 * Load the current entry for the given object
 * into the given update form.
 *
 ****************************************************************************/

/* ARGSUSED */
void displayEntryTemplate(prim_widget,
		   objid,
		   primid,
		   actid,
		   actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  WidgetList prim_insts;

  prim_insts = XLUgetPrimitiveList(objid, MODIFY);
  if (prim_insts != (Widget *) NULL)
    {
      /* ####### Go thru all instances ! ###### */
      setUpdateState(prim_insts[0], FALSE, NoEntry);

      doUpdateModifyForm(prim_insts[0],
			 objid,
			 primid,
			 actid,
			 actlist);

      XtFree((char *) prim_insts);
      XLUstatusMessage(objid, "Reading entry. Please wait.");
    }
} /* displayEntryTemplate */

/*****************************************************************************
 * doUpdateModifyForm()
 *
 * Request a directory read prior to displaying into modify primitive.
 *
 ****************************************************************************/

void doUpdateModifyForm(prim_widget,
			objid,
			primid,
			actid,
			actlist)
     Widget prim_widget;
     int objid;
     int primid;
     int actid;
     XLUactionList actlist;
{
  QyErrorCode read_state;
  int request_id;
  String strdn;
  XLUwindowObject this_object;
  QyModifyAttr curr_attr;

  this_object = XLUgetWindowObject(objid);

  if (this_object->current_entry != NULLEntryList)
    strdn = this_object->current_entry->string_dn;
  else
    strdn = NULLString;
  
  /***************************************************
   *
   * Initiate the read request.
   *
   */
  
  curr_attr = NULLModifyAttr;
  if (strdn != NULLString)
    read_state = QyMakeEntryTemplate(strdn, &request_id, &curr_attr);
  else
    {
      XLUstatusMessage(objid, "No entry name given to read!");
      return;
    }
  
  switch (read_state)
    {
    case QERR_bad_value_syntax:
      XLUstatusMessage(objid, "Can't get data! Bad entry name supplied.");
      return;
      
    case QERR_internal_limit_reached:
      XLUstatusMessage(objid, "Can't get data! Internal limit reached.");
      return;
      
      default:
      break;
    }
  
  /***************************************************
   *
   * Record request invocation.
   *
   */
  
  XLUrequestInvoked(request_id,
		  ENTRY_TEMPLATE,
		  gotEntryTemplateResult,
		  (DSReportCallback) NULL,
		  prim_widget, 
		  objid,
		  primid,
		  actid,
		  actlist == NULLActionList? actlist : actlist->next);
} /* doUpdateModifyForm */

/*****************************************************************************
 * displayClassTemplate()
 *
 * Create and display a template (with default values) for a given
 * entry class.
 * 
 ****************************************************************************/

void displayClassTemplate(new_name, class, pw, objid)
     String new_name;
     XLUentryClass class;
     Widget pw;
     int objid;
{
  Widget menu, mitem, entry_name, pulldown, first_entry;
  Arg args[MAXARGS];
  int count, num_children;
  WidgetList children;
  caddr_t data;
  stringCell group_list;
  BOOLEAN oclass_done = FALSE;
  AttributeType oclass = AttrT_new("2.5.4.0");
  XLUattributeGroup group;
  XLUupdateContext modstate;
  modifyEntry mod_entry;
  modifyGroup mod_group;
  attrTypeList templates_used = NULLAttrTypeList, curr_used, ocs;
  XLUattrTemplate template;
  XmString labelstr;
  
  mod_entry = mod_entry_alloc();
  mod_entry->name = XtNewString(new_name);
  mod_entry->current_dn = NULLString;
  mod_entry->groups = NULLModifyGroup;
  mod_entry->undisplayed = NULLModifyAttr;
  
  /***************************************************
   *
   * Get groups and add to entry template.
   *
   */
  
  for (group_list = class->groups;
       group_list != NULLStrCell;
       group_list = group_list->next)
    {
      for (group = attr_group_list;
	   group != NULLAttrGroup;
	   group = group->next)
	if (lexequ(group->name, group_list->string) == 0)
	  {
	    mod_group = mod_group_alloc();
	    
	    mod_group->next = mod_entry->groups;
	    mod_entry->groups = mod_group;
	    
	    mod_group->group = group;
	    mod_group->fields = NULLModifyField;
	  }
    }
  
  /***************************************************
   *
   * Insert attributes into groups.
   *
   */
  
  for (mod_group = mod_entry->groups;
       mod_group != NULLModifyGroup;
       mod_group = mod_group->next)
    {
      QyModifyAttr attr;
      modifyField field;
      attrTypeList type;
      stringCell str_val;
      
      for (type = mod_group->group->attributes;
	   type != NULLAttrTypeList;
	   type = type->next)
	{
	  BOOLEAN must = FALSE;
	  modifyField curr_field;
	  
	  if (oclass_done == FALSE && type->type == oclass)
	    {
	      attr = NULLModifyAttr;
	      oclass_done = TRUE;
	      
	      for (ocs = class->oc_list;
		   ocs != NULLAttrTypeList;
		   ocs = ocs->next)
		{
		  field = newModifyField(&attr,
					 oclass,
					 getAttributeName(ocs->type));
		  
		  if (mod_group->fields == NULLModifyField)
		    mod_group->fields = field;
		  else
		    {
		      for (curr_field = mod_group->fields;
			   curr_field->next != NULLModifyField;
			   curr_field = curr_field->next)
			;
		      
		      curr_field->next = field;
		    }
		}
	      
	      continue;
	    }
	  
	  for (ocs = class->oc_list;
	       ocs != NULLAttrTypeList;
	       ocs = ocs->next)
	    {
	      if (QyIsObjectClassAttr(name2oc(ocs->type->oa_ot.ot_stroid),
			     type->type,
			     &must))
		{
		  /***************************************************
		   *
		   * Get default values, if any.
		   *
		   */
		  
		  for (template = attr_template_list;
		       template != NULLAttrTemplate;
		       template = template->next)
		    if (SeqMemberString(class->name,
					 template->class_names)
			&& type->type == template->type)
		      {
			(void) QyATListAdd(template->type,
						&templates_used);
			break;
		      }
		  
		  if (template == NULLAttrTemplate)
		    {
		      attr = NULLModifyAttr;
		      
		      field = newModifyField(&attr,
					     type->type,
					     NULLString);
		      
		      if (mod_group->fields == NULLModifyField)
			mod_group->fields = field;
		      else
			{
			  for (curr_field = mod_group->fields;
			       curr_field->next != NULLModifyField;
			       curr_field = curr_field->next)
			    ;
			  
			  curr_field->next = field;
			}
		    }
		  else
		    {
		      attr = NULLModifyAttr;
		      
		      for (str_val = template->defaults;
			   str_val != NULLStrCell;
			   str_val = str_val->next)
			{
			  field = newModifyField(&attr,
						 type->type,
						 str_val->string);
			  
			  if (mod_group->fields == NULLModifyField)
			    mod_group->fields = field;
			  else
			    {
			      for (curr_field = mod_group->fields;
				   curr_field->next != NULLModifyField;
				   curr_field = curr_field->next)
				;
			      
			      curr_field->next = field;
			    }
			}
		    }
		  
		  break;
		}
	    }
	}
    }
  
  /***************************************************
   *
   * Add template values to "undisplayed" list.
   *
   */
  
  for (template = attr_template_list;
       template != NULLAttrTemplate;
       template = template->next)
    {
      for (curr_used = templates_used;
	   curr_used != NULLAttrTypeList;
	   curr_used = curr_used->next)
	if (curr_used->type == template->type)
	  break;
      
      if (curr_used == NULLAttrTypeList)
	/***************************************************
	 *
	 * This default value isn't displayed.
	 * Check if it's in the object classes
	 * defined by the entry class. If so
	 * add it to the undisplayed list.
	 *
	 */
	{
	  BOOLEAN must = FALSE;
	  attrTypeList oclist;
	  
	  for (oclist = class->oc_list;
	       oclist != NULLAttrTypeList;
	       oclist = oclist->next)
	    if (QyIsObjectClassAttr(name2oc(oclist->type->oa_ot.ot_stroid),
			   template->type,
			   &must) &&
		must == TRUE)
	      {
		QyModifyAttr attr = modify_attr_alloc();
		QyModifyValue value = NULLModifyValue;
		stringCell defaults = template->defaults;
		
		attr->to_modify = FALSE;
		attr->attr_type = template->type;
		
		attr->next = mod_entry->undisplayed;
		mod_entry->undisplayed = attr;
		
		attr->values = NULLModifyValue;
		
		while (defaults != NULLStrCell)
		  {
		    value = modify_value_alloc();
		    
		    value->value = XtNewString(defaults->string);
		    value->new_value = NULLString;
		    
		    value->next = attr->values;
		    attr->values = value;
		    
		    value->status = QMVunchanged;
		    
		    defaults = defaults->next;
		  }
		
		break;
	      }
	}
    }
  
  /***************************************************
   *
   * Add object class values if not already added.
   *
   */
  
  if (oclass_done == FALSE)
    {
      QyModifyAttr attr = modify_attr_alloc();
      QyModifyValue value = NULLModifyValue;
      
      attr->to_modify = FALSE;
      attr->attr_type = oclass;
      
      attr->next = mod_entry->undisplayed;
      mod_entry->undisplayed = attr;
      
      attr->values = NULLModifyValue;
      
      for (ocs = class->oc_list;
	   ocs != NULLAttrTypeList;
	   ocs = ocs->next)
	{
	  value = modify_value_alloc();
	  
	  value->value = XtNewString(getAttributeName(ocs->type));
	  value->new_value = NULLString;
	  
	  value->next = attr->values;
	  attr->values = value;
	  
	  value->status = QMVunchanged;
	}
    }
  
  /***************************************************
   *
   * Point to new entry template and free old data.
   *
   */

  modstate = (XLUupdateContext) XLUgetPrimitiveData(pw);
  
  if (modstate->modentry != NULLModifyEntry)
    freeModifyEntry(modstate->modentry);

  modstate->modentry = mod_entry;
  
  /***************************************************
   *
   * Add entries to group selection menu.
   *
   */
  
  menu = XtNameToWidget(pw, "groupOptionMenu");
  XtSetArg(args[0], XmNsubMenuId, &pulldown);
  XtGetValues(menu, args, 1);

  XtSetArg(args[0], XmNchildren, &children);
  XtSetArg(args[1], XmNnumChildren, &num_children);
  XtGetValues(pulldown, args, 2);
  
  if (num_children > 0)
    {
      XtUnmanageChildren(children, num_children);
      
      for (count = 0; count < num_children; count++)
	XtDestroyWidget(children[count]);
    }

  /**************************************************
   *
   * Add a menu entry for each attribute group.
   * 
   */

  first_entry = NULLWidget;
  for (mod_group = mod_entry->groups, count = 0;
       mod_group != NULLModifyGroup;
       mod_group = mod_group->next, count++)
    {
      mitem =
	XmCreatePushButtonGadget(pulldown, mod_group->group->name, args, 0);

      XtManageChild(mitem);

      if (first_entry == NULLWidget)
	first_entry = mitem;
      
      XtAddCallback
	(mitem, XmNactivateCallback, displaySelectedGroup, (XtPointer) count);
    }

  XtUnmanageChild(menu);
  XtManageChild(menu);

  /**************************************************
   *
   * Set label of menu button to be first
   * listed group.
   * 
   */

  if (mod_entry->groups != NULLModifyGroup)
    {
      XtSetArg(args[0], XmNmenuHistory, first_entry);
      XtSetValues(pulldown, args, 1);

      labelstr = XmStringCreateSimple(mod_entry->groups->group->name);
      XtSetArg(args[0], XmNlabelString, labelstr);

      XtSetValues(XmOptionButtonGadget(menu), args, 1);
      XmStringFree(labelstr);
    }
  
  /***************************************************
   *
   * Display first attribute group.
   *
   */
  
  displayGroup(objid, 0);
  
  /***************************************************
   *
   * Display entry name.
   *
   */
  
  entry_name = XtNameToWidget(pw, "entryNameEdit");
  XtSetArg(args[0], XmNvalue, new_name);

  XtSetValues(entry_name, args, 1);
} /* displayClassTemplate */

/*****************************************************************************
 * newModifyField()
 *
 * Create a new modifyField structure with the appropriate bits filled out.
 * Supply the attr_ptr parameter if a new QyModifyAttr structure is required.
 * 
 ****************************************************************************/

static modifyField newModifyField(attr_ptr, type, string_value)
     QyModifyAttr *attr_ptr;
     AttributeType type;
     String string_value;
{
  modifyField field;
  QyModifyValue value;
  QyModifyAttr attr = *attr_ptr;
  
  field = mod_field_alloc();
  
  field->changed = FALSE;
  field->is_active = TRUE;
  
  field->is_rdn = FALSE;
  field->is_must = FALSE;	/* Not always so! */
  
  field->edit = NULLWidget;
  field->syntax = type->oa_syntax;
  
  if (attr == NULLModifyAttr)
    {
      attr = field->this_attr = *attr_ptr = modify_attr_alloc();
      
      attr->attr_name =	XtNewString(type->oa_ot.ot_name);
      attr->attr_type = type;
      
      attr->to_modify = FALSE;
      attr->next = NULLModifyAttr;
      
      attr->values = NULLModifyValue;
    }
  else
    field->this_attr = attr;
  
  field->next = NULLModifyField;
  
  value = 
    attr->values =
      field->this_value =
	modify_value_alloc();
  
  if (string_value != NULLString)
    value->value = XtNewString(string_value);
  else
    value->value = NULLString;
  
  value->new_value = NULLString;
  value->status = QMVunchanged;
  value->next = NULLModifyValue;
  
  return field;
} /* newModifyField */

/*****************************************************************************
 * gotEntryTemplateResult()
 *
 * An entry template has been received,
 * work out it's entry class
 *
 ****************************************************************************/

/* ARGSUSED */
void gotEntryTemplateResult(request_id, this_objid, actid, actlist)
     int request_id;
     int this_objid;
     int actid;
     XLUactionList actlist;
{
  char entry_name[LINESIZE];
  QyTemplateResult result;
  
  /***************************************************
   *
   * Notify user.
   *
   */
  
  XBell(dpy, 40);
  XLUstatusMessage(this_objid, "Read result received.");
  
  result = QyGetTemplateResult(request_id);
  
  if (result->errors != NULLError)
    {
      QyPrintFriendlyDN(result->errors->baseobject, entry_name);
      (void) sprintf(err_msg,
		     "Couldn't read `%.24s' because;\n%s",
		     entry_name,
		     QyPrintErrcode(result->errors->error_type));
      
      XLUsetWindowErrors(this_objid, result->errors);
      result->errors = NULLError;
      
      XLUstatusMessage(this_objid, err_msg);
    }
  else
    {
      WidgetList instances;
      Widget menu, mitem, name, pulldown, first_entry;
      Arg args[MAXARGS];
      int count;
      XmString labelstr;
      XLUentryClass curr_class;
      stringCell class_name_list = NULLStrCell, group_list;
      QyModifyValue curr_oc;
      XLUattributeGroup group;
      modifyEntry mod_entry;
      modifyGroup mod_group;
      XtPointer ptr;
      XLUupdateContext modstate;
      
      instances = XLUgetPrimitiveList(this_objid, MODIFY);
      if (instances == (Widget *) NULL)
	{
	  XtFree((char *) instances);
	  XLUrequestComplete(request_id);
	  QyFreeTemplateResult(&result);
	  
	  return;
	}
      
      /***************************************************
       *
       * Get entry class(es).
       *
       */
      
      for (curr_oc = result->object_class->values;
	   curr_oc != NULLModifyValue;
	   curr_oc = curr_oc->next)
	for (curr_class = entry_class_list;
	     curr_class != NULLEntryClass;
	     curr_class = curr_class->next)
	  if (name2oc(curr_oc->value) ==
	      name2oc(curr_class->oc_list->type->oa_ot.ot_stroid))
	    SeqAddString(curr_class->name, &class_name_list);
      
      if (class_name_list == NULLStrCell)
	{
	  /* Nothing yet! */
	}
      
      QyPrintFriendlyDN(result->base_object, entry_name);
      mod_entry = mod_entry_alloc();
      
      mod_entry->name = XtNewString(entry_name);
      mod_entry->current_dn = XtNewString(result->base_object);
      
      mod_entry->groups = NULLModifyGroup;
      mod_entry->undisplayed = NULLModifyAttr;
      
      for (curr_class = entry_class_list;
	   curr_class != NULLEntryClass;
	   curr_class = curr_class->next)
	if (lexequ(curr_class->name , class_name_list->string) == 0)
	  break;
      
      group_list = curr_class->groups;
      SeqFree(&class_name_list);
      
      /***************************************************
       *
       * Get groups and insert into entry.
       *
       */
      
      while (group_list != NULLStrCell)
	{
	  for (group = attr_group_list;
	       group != NULLAttrGroup;
	       group = group->next)
	    if (lexequ(group->name, group_list->string) == 0)
	      {
		mod_group = mod_group_alloc();
		
		mod_group->next = mod_entry->groups;
		mod_entry->groups = mod_group;
		
		mod_group->group = group;
		mod_group->fields = NULLModifyField;
	      }
	  
	  group_list = group_list->next;
	}
      
      /***************************************************
       *
       * Put attributes into groups.
       *
       */
      
      for (mod_group = mod_entry->groups;
	   mod_group != NULLModifyGroup;
	   mod_group = mod_group->next)
	{
	  QyModifyValue value;
	  QyModifyAttr attr, prev_attr;
	  modifyField field;
	  attrTypeList type;
	  
	  for (type = mod_group->group->attributes;
	       type != NULLAttrTypeList;
	       type = type->next)
	    {
	      BOOLEAN must = TRUE;
	      
	      for (attr = result->must_exc, prev_attr = NULLModifyAttr;
		   attr != NULLModifyAttr;
		   prev_attr = attr, attr = attr->next)
		if (attr->attr_type == type->type)
		  break;
	      
	      if (attr == NULLModifyAttr)
		{
		  for (attr = result->may_exc, prev_attr = NULLModifyAttr;
		       attr != NULLModifyAttr;
		       prev_attr = attr, attr = attr->next)
		    if (attr->attr_type == type->type)
		      break;
		  
		  must = FALSE;
		}
	      
	      if (attr != NULLModifyAttr)
		{
		  if (prev_attr == NULLModifyAttr)
		    {
		      if (must)
			result->must_exc = attr->next;
		      else
			result->may_exc = attr->next;
		    }
		  else
		    prev_attr->next = attr->next;
		  
		  attr->next = NULLModifyAttr;
		  
		  for (value = attr->values;
		       value != NULLModifyValue;
		       value = value->next)
		    {
		      if (mod_group->fields == NULLModifyField)
			field = mod_group->fields = mod_field_alloc();
		      else
			{
			  for (field = mod_group->fields;
			       field->next != NULLModifyField;
			       field = field->next)
			    ;
			  
			  field->next = mod_field_alloc();
			  field = field->next;
			}
		      
		      field->changed = FALSE;
		      field->is_active = TRUE;
		      
		      field->is_rdn = FALSE;
		      field->is_must = must;
		      
		      field->edit = NULLWidget;
		      
		      field->this_attr = attr;
		      field->this_value = value;
		      
		      field->next = NULLModifyField;
		      field->syntax = attr->attr_type->oa_syntax;
		    }
		}
	    }
	}
      
      /***************************************************
       *
       * Set status.
       *
       */
      
      setUpdateState(instances[0], FALSE, Modifying);
      
      /***************************************************
       *
       * Save pointer to entry.
       *
       */

      modstate = (XLUupdateContext) XLUgetPrimitiveData(instances[0]);

      if (modstate->modentry != NULLModifyEntry)
	freeModifyEntry(modstate->modentry);
      
      modstate->modentry = mod_entry;
      
      /***************************************************
       *
       * Add entries to group selection menu.
       *
       */
      
      menu = XtNameToWidget(instances[0], "groupOptionMenu");
      XtSetArg(args[0], XmNsubMenuId, &pulldown);
      XtGetValues(menu, args, 1);
      
      first_entry = NULLWidget;
      for (mod_group = mod_entry->groups, count = 0;
	   mod_group != NULLModifyGroup;
	   mod_group = mod_group->next, count++)
	{
	  mitem =
	    XmCreatePushButtonGadget(pulldown, mod_group->group->name, args,0);

	  if (first_entry == NULLWidget)
	    first_entry = mitem;

	  XtManageChild(mitem);
	  XtAddCallback(mitem,
			XmNactivateCallback,
			displaySelectedGroup,
			(XtPointer) count);
	}

      XtUnmanageChild(menu);
      XtManageChild(menu);

      /**************************************************
       *
       * Add name of default group in menu button.
       * 
       */

      if (mod_entry->groups != NULLModifyGroup)
	{
	  XtSetArg(args[0], XmNmenuHistory, first_entry);
	  XtSetValues(pulldown, args, 1);

	  labelstr = XmStringCreateSimple(mod_entry->groups->group->name);
	  XtSetArg(args[0], XmNlabelString, labelstr);
	  
	  XtSetValues(XmOptionButtonGadget(menu), args, 1);
	  XmStringFree(labelstr);
	}

      displayGroup(this_objid, 0);
      
      /***************************************************
       *
       * Display entry name.
       *
       */
      
      QyPrintFriendlyDN(result->base_object, entry_name);
      name = XtNameToWidget(instances[0], "entryNameEdit");
      
      XtSetArg(args[0], XmNvalue, entry_name);
      XtSetValues(name, args, 1);
      
      XtFree((char *) instances);
    }
  
  XLUrequestComplete(request_id);
  
  QyFreeTemplateResult(&result);
} /* gotEntryTemplateResult */

/*****************************************************************************
 * displaySelectedGroup()
 *
 * Display a selected attribute group. The closure parameter is
 * an integer index to a group.
 *
 ****************************************************************************/

/* ARGSUSED */
static void displaySelectedGroup(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  displayGroup(XLUgetWindowObjectId(w), (int) closure);
} /* displaySelectedGroup */

/*****************************************************************************
 * displayGroup()
 *
 * Display the group of attributes indexed from
 * the set for the current entry.
 *
 ****************************************************************************/

static void displayGroup(objid, grpidx)
     int objid;
     int grpidx;
{
  WidgetList instances, children;
  Widget primitive, port, view_form, attribute_form;
  modifyEntry modentry;
  modifyGroup group;
  modifyField field;
  QyModifyAttr attribute;
  int count, num_children, group_count;
  Arg args[MAXARGS];
  caddr_t ptr;
  XLUupdateContext modstate;
  
  instances = XLUgetPrimitiveList(objid, MODIFY);
  if (instances == (Widget *) NULL)
    {
      XtFree((char *) instances);
      return;
    }
  
  primitive = instances[0];
  port = XtNameToWidget(primitive, "modifyWindow");

  XtSetArg(args[0], XmNworkWindow, &view_form);
  XtGetValues(port, args, 1);
  
  XtFree((char *) instances);
  
  /***************************************************
   *
   * Retrieve pointer to entry then get indexed group.
   *
   */

  modstate = (XLUupdateContext) XLUgetPrimitiveData(primitive);
  modentry = modstate->modentry;
  
  for (group = modentry->groups, group_count = 0;
       group != NULLModifyGroup;
       group = group->next, group_count++)
    ;
  
  if (grpidx < 0)
    grpidx = group_count - 1;
  
  for (group = modentry->groups, count = 0;
       group != NULLModifyGroup && count < grpidx;
       group = group->next, count++)
    ;
  
  if (group == NULLModifyGroup)
    {
      group = modentry->groups;
      grpidx = 0;
    }

  /* Save index of attribute group */
  XtSetArg(args[0], XmNuserData, (XtPointer) grpidx);
  XtSetValues(view_form, args, 1);

  /**************************************************
   *
   * Hide form widget whilst adding new fields.
   * 
   */

  XtUnmanageChild(view_form);
  
  /***************************************************
   *
   * Delete old attribute dialogues.
   *
   */
  
  XtSetArg(args[0], XmNchildren, &children);
  XtSetArg(args[1], XmNnumChildren, &num_children);
  XtGetValues(view_form, args, 2);
  
  if (num_children > 0)
    {
      XtUnmanageChildren(children, num_children);
      
      for (count = 0; count < num_children; count++)
	XtDestroyWidget(children[count]);
    }
  
  /***************************************************
   *
   * Add attributes.
   *
   */
  
  if ((field = group->fields) != NULLModifyField)
    {
      attribute_form = displayGroupAttribute(field,
					     group,
					     view_form,
					     NULLWidget,
					     FALSE,
					     TRUE);
    }
  
  if (field != NULLModifyField)
    for (attribute = field->this_attr;
	 field != NULLModifyField && attribute == field->this_attr;
	 field = field->next)
      ;
  
  while (field != NULLModifyField)
    {
      attribute_form = displayGroupAttribute(field,
					     group,
					     view_form,
					     attribute_form,
					     FALSE,
					     FALSE);
      
      for (attribute = field->this_attr;
	   field != NULLModifyField && attribute == field->this_attr;
	   field = field->next)
	;
    }

  /**************************************************
   *
   * Re-manage form window, showing new fields.
   * 
   */

  XtManageChild(view_form);

  XtSetSensitive(port, FALSE);
  XtSetSensitive(port, TRUE);
} /* displayGroup */

/*****************************************************************************
 * displayGroupAttribute()
 *
 * Add the given attribute to the display form.
 *
 ****************************************************************************/

/* ARGSUSED */
static Widget displayGroupAttribute(field,
				    group,
				    parent_form,
				    from_vert,
				    do_one,
				    give_focus)
     modifyField field;
     modifyGroup group;
     Widget parent_form;
     Widget from_vert;
     BOOLEAN do_one;
     BOOLEAN give_focus;
{
  QyModifyAttr attribute;
  QyModifyValue value;
  AttributeType type;
  Widget form, attrbtn, rowcol, prev_edit, mitem;
  int count, editcount;
  Arg args[MAXARGS];
  modifyField empty;
  XmString labelstr;
  
  attribute = field->this_attr;
  type = attribute->attr_type;
  
  /***************************************************
   *
   * Each attribute editor is contained in
   * it's own form.
   *
   */
  
  count = 0;
  
  if (from_vert != NULLWidget)
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
      XtSetArg(args[count], XmNtopWidget, from_vert); count++;
    }
  else
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_FORM); count++;
    }
  
  XtSetArg(args[count], XmNbottomAttachment, XmATTACH_NONE); count++;
  XtSetArg(args[count], XmNresizable, TRUE); count++;

  XtSetArg(args[count], XmNresizePolicy, XmRESIZE_ANY); count++;
  form = XmCreateForm(parent_form, "attributeForm", args, count);

  XtManageChild(form);
  
  /***************************************************
   *
   * Create an attribute editor, with the
   * type of editor depenedent on the syntax
   * of the attribute.
   *
   */
  
  switch (type->oa_syntax)
    {
      default:
      /***************************************************
       *
       * Default is text based attributes.
       *
       */
      
      /**************************************************
       *
       * Button press in label gadget posts menu.
       * 
       */

      labelstr = XmStringCreateSimple(getAttributeName(type));

      count = 0;

      XtSetArg(args[count], XmNlabelString, labelstr); count++;
      XtSetArg(args[count], XmNresizable, TRUE); count++;

      XtSetArg(args[count], XmNshadowThickness, 1); count++;
      attrbtn = XmCreateLabel(form, "modifyTypeButton", args, count);
      
      XmStringFree(labelstr);

      XmAddTabGroup(attrbtn);
      XtManageChild(attrbtn);
      
      /***************************************************
       *
       * Per attribute menu and items.
       *
       */
      
      XtSetArg(args[0], XmNmenuPost, "<Btn1Down>");
      rowcol = XmCreatePopupMenu(attrbtn, "menu", args, 1);
      
      if (type->oa_syntax < AV_WRITE_FILE)
	{
	  mitem = XmCreatePushButtonGadget(rowcol, "addNewVal", args, 0);
	  
	  XtManageChild(mitem);
	  XtAddCallback(mitem,
			XmNactivateCallback,
			addValue,
			(XtPointer) field);
	}
      
      mitem = XmCreatePushButtonGadget(rowcol, "undoAllChanges", args, 0);
      
      XtManageChild(mitem);
      XtAddCallback(mitem,
		    XmNactivateCallback,
		    undoAllChanges,
		    (XtPointer) field);

      XtAddEventHandler(attrbtn, ButtonPressMask, FALSE, XLUpostMenu, rowcol);
      
      /***************************************************
       *
       * Create edit fields and menus for each value.
       *
       */
      
      editcount = 0;
      empty = NULLModifyField;
      
      for (prev_edit = NULLWidget;
	   field != NULLModifyField && field->this_attr == attribute;
	   field = field->next)
	{
	  value = field->this_value;
	  if ((value->value == NULLString && value->new_value == NULLString)
	      || value->status == QMVdeleted)
	    {
	      if (empty == NULLModifyField)
		empty = field;
	      
	      continue;
	    }
	  
	  prev_edit = createValueEdit(attrbtn, prev_edit, form, field);
	  
	  if (prev_edit != NULLWidget)
	    editcount++;
	}
      
      /**************************************************
       *
       * Only display a field with no values if 
       * no fields with values exist.
       * 
       */
      
      if (editcount == 0)
	{
	  empty->this_value->status = QMVunchanged;
	  empty->this_value->new_value = "";
	  
	  prev_edit = createValueEdit(attrbtn,
				      prev_edit,
				      form,
				      empty);
	  
	  empty->this_value->new_value = NULLString;
	  empty->this_value->status = QMVdeleted;
	}
      
      break;
    }
  
  return form;
} /* displayGroupAttribute */

/*****************************************************************************
 * modifyFieldUpdate()
 *
 * A field has been edited. Set it's update flag.
 *
 ****************************************************************************/

/* ARGSUSED */
static void modifyFieldUpdate(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  modifyField field = (modifyField) closure;
  field->changed = TRUE;
} /* modifyFieldUpdate */

/*****************************************************************************
 * modifyFieldDestroyed()
 *
 * A field is being destroyed. If the field has been edited save
 * the new value entered.
 * 
 ****************************************************************************/

/* ARGSUSED */
static void modifyFieldDestroyed(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  modifyField field = (modifyField) closure;
  QyModifyValue modval;
  int count;
  Arg args[MAXARGS];
  String new_value, tidyval;
  BOOLEAN haveNew = FALSE, haveOld = FALSE, noChange = FALSE;
  
  field->edit = NULLWidget;
  
  if (field->changed == TRUE)
    {
      modval = field->this_value;
      
      count = 0;
      XtSetArg(args[count], XmNvalue, &new_value); count++;
      XtGetValues(w, args, count);
      
      if (modval->new_value != NULLString)
	XtFree(modval->new_value);
      
      new_value = XtNewString(new_value);
      
      tidyval = TidyString(new_value);
      tidyval = XtNewString(tidyval);
      
      XtFree(new_value);
      new_value = tidyval;
      
      if (!isnull(*new_value))
	{
	  if (lexequ(new_value, modval->value) == 0)
	    /**************************************************
	     *
	     * Old and new values the same!
	     * 
	     */
	    {
	      XtFree(new_value);
	      modval->new_value = new_value = NULLString;
	      
	      haveNew = FALSE;
	      noChange = TRUE;
	    }
	  else
	    {
	      haveNew = TRUE;
	      modval->new_value = new_value;
	    }
	}
      else
	modval->new_value = NULLString;
      
      if (modval->value == NULLString || isnull(*modval->value))
	haveOld = FALSE;
      else
	haveOld = TRUE;
      
      if (haveNew == TRUE && haveOld == TRUE)
	modval->status = QMVupdated;
      else if (haveNew == TRUE)
	modval->status = QMVnew;
      else if (noChange == TRUE)
	modval->status = QMVunchanged;
      else
	modval->status = QMVdeleted;
    }
} /* modifyFieldDestroyed */

/*****************************************************************************
 * displayNextGroup()
 *
 * Display the next group of attributes.
 * 
 ****************************************************************************/

/* ARGSUSED */
void displayNextGroup(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  int objid;
  WidgetList instances;
  Widget modify, form, port;
  XtPointer ptr;
  int grpidx;
  Arg args[MAXARGS];
  
  /**************************************************
   *
   * Get the object id of this window, use that
   * to obtain an instance of the modify form.
   *
   */
  
  objid = XLUgetWindowObjectId(w);
  instances = XLUgetPrimitiveList(objid, MODIFY);
  
  /* This shouldn't happen. */
  if (instances == (Widget *) NULL)
    {
      XtFree((char *) instances);
      return;
    }
  
  modify = instances[0];
  XtFree((char *) instances);
  
  port = XtNameToWidget(modify, "modifyWindow");
  XtSetArg(args[0], XmNworkWindow, &form);
  XtGetValues(port, args, 1);
  
  /**************************************************
   *
   * Get the modifyEntry pointer held in
   * an XContext associated with the "modify"
   * widget window.
   * 
   */
  
  XtSetArg(args[0], XmNuserData, &ptr);
  XtGetValues(form, args, 1);

  grpidx = (int) ptr;
  displayGroup(objid, ++grpidx);  
} /* displayNextGroup */

/*****************************************************************************
 * displayPreviousGroup()
 *
 * Display the previous group of attributes.
 *
 ****************************************************************************/

/* ARGSUSED */
void displayPreviousGroup(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  int objid;
  WidgetList instances;
  Widget modify, form, port;
  XtPointer ptr;
  int grpidx;
  Arg args[MAXARGS];
  
  /**************************************************
   *
   * Get the object id of this window, use that
   * to obtain an instance of the modify form.
   *
   */
  
  objid = XLUgetWindowObjectId(w);
  instances = XLUgetPrimitiveList(objid, MODIFY);
  
  /* This shouldn't happen. */
  if (instances == (Widget *) NULL)
    {
      XtFree((char *) instances);
      return;
    }
  
  modify = instances[0];
  XtFree((char *) instances);
  
  port = XtNameToWidget(modify, "modifyWindow");
  XtSetArg(args[0], XmNworkWindow, &form);
  XtGetValues(port, args, 1);
  
  /**************************************************
   *
   * Get the modifyEntry pointer held in
   * an XContext associated with the "modify"
   * widget window.
   * 
   */

  XtSetArg(args[0], XmNuserData, &ptr);
  XtGetValues(form, args, 1);
 
  grpidx = (int) ptr;
  displayGroup(objid, --grpidx);
} /* displayPreviousGroup */

/*****************************************************************************
 * freeModifyEntry()
 *
 * Free a modifyEntry structure. 
 *
 ****************************************************************************/

/* ARGSUSED */
static void freeModifyEntry(modentry)
     modifyEntry modentry;
{
  modifyGroup group, last_group = NULLModifyGroup;
  modifyField field, last_field = NULLModifyField;
  QyModifyAttr attr = NULLModifyAttr;

  if (modentry == NULLModifyEntry)
    return;
  
  for (group = modentry->groups; group != NULLModifyGroup; group = group->next)
    {
      if (last_group != NULLModifyGroup)
	{
	  XtFree((char *) last_group);
	  last_group = group;
	}
      
      for (field = group->fields; field != NULLModifyField;field = field->next)
	{
	  if (last_field != NULLModifyField)
	    {
	      XtFree((char *) last_field);
	      last_field = field;
	    }
	  
	  if (attr != field->this_attr)
	    {
	      attr = field->this_attr;
	      
	      attr->next = NULLModifyAttr;
	      attr->values = NULLModifyValue;
	      
	      attr = field->this_attr;
	      free_mod_attr_list(&field->this_attr);
	    }
	  
	  field->this_value->next = NULLModifyValue;
	  free_mod_val_list(&(field->this_value));
	}
      
      if (last_field != NULLModifyField)
	XtFree((char *) last_field);
    }
  
  if (last_group != NULLModifyGroup)
    XtFree((char *) last_group);
  
  XtFree(modentry->name);
  if (modentry->current_dn != NULLString)
    XtFree(modentry->current_dn);
  
  XtFree((char *) modentry);
} /* freeModifyEntry */

/*****************************************************************************
 * setUpdateState()
 *
 * Set the update state flags for an entry.
 *
 ****************************************************************************/

void setUpdateState(w, changes, state)
     Widget w;
     BOOLEAN changes;
     XLUupdateState state;
{
  Widget add, delete, commit;
  XLUupdateContext modstate;
  
  modstate = (XLUupdateContext) XLUgetPrimitiveData(w);
  modstate->changes = changes;
  modstate->state = state;
  
/*
  commit = XtNameToWidget(w, "commitModificationsButton");
  add = XtNameToWidget(w, "addEntryButton");
  delete = XtNameToWidget(w, "deleteEntryButton");
  
  switch (state)
    {
    case Composing:
      
      XtSetSensitive(delete, TRUE);
      XtSetSensitive(add, TRUE);
      XtSetSensitive(commit, TRUE);
      
      break;
      
    case NoEntry:
      
      XtSetSensitive(add, TRUE);
      XtSetSensitive(delete, FALSE);
      XtSetSensitive(commit, FALSE);
      
      break;
      
    case Modifying:
      
      XtSetSensitive(commit, TRUE);
      XtSetSensitive(add, TRUE);
      XtSetSensitive(delete, TRUE);
      
      break;
    }
*/
} /* setUpdateState */

/*****************************************************************************
 * getUpdateState()
 *
 * Get state flags for an entry.
 *
 ****************************************************************************/

void getUpdateState(w, changes_ptr, state_ptr)
     Widget w;
     BOOLEAN *changes_ptr;
     XLUupdateState *state_ptr;
{
  XLUupdateContext state;
  XtPointer ptr;
  
  ptr = XLUgetPrimitiveData(w);
  state = (XLUupdateContext) ptr;
  
  if (changes_ptr != (BOOLEAN *) NULL)
    *changes_ptr = state->changes;
  
  if (state_ptr != (XLUupdateState *) NULL)
    *state_ptr = state->state;
} /* getUpdateState */

/*****************************************************************************
 * updateFieldData()
 *
 * Make sure that the field flags are up to date.
 *
 ****************************************************************************/

void updateFieldData(mentry)
     modifyEntry mentry;
{
  modifyGroup group;
  modifyField field;
  QyModifyValue value = NULLModifyValue;
  
  for (group = mentry->groups; group != NULLModifyGroup; group = group->next)
    {
      field = group->fields;
      
      while (field != NULLModifyField)
	{
	  value = field->this_value;
	  
	  /**************************************************
	   *
	   * Field record flags.
	   * 
	   */
	  
	  field->changed = FALSE;
	  
	  /**************************************************
	   *
	   * Attribute value record flags.
	   * 
	   */
	  
	  switch (value->status)
	    {
	    case QMVupdated:
	      
	      XtFree(value->value);
	      value->value = value->new_value;
	      value->new_value = NULLString;
	      
	      field = field->next;
	      
	      break;
	      
	    case QMVnew:
	      
	      value->value = value->new_value;
	      value->new_value = NULLString;
	      
	      field = field->next;
	      
	      break;
	      
	    case QMVdeleted:
	      
	      if (field->edit == NULLWidget)
		{
		  if (value->value != NULLString)
		    XtFree(value->value);
		  
		  value->value = NULLString;
		  
		  field = field->next;
		}
	      else
		{
		  if (value->value != NULLString)
		    {
		      XtFree(value->value);
		      value->value = NULLString;
		    }
		  
		  field = field->next;
		}
	      
	      break;
	      
	      default:
	      
	      field = field->next;
	      
	      break;
	    }
	  
	  if (value != NULLModifyValue)
	    value->status = QMVunchanged;
	  
	  /**************************************************
	   *
	   * Attribute level settings.
	   * 
	   */
	  
	  if (field != NULLModifyField)
	    field->this_attr->to_modify = FALSE;
	}
    }
} /* updateFieldData */


/*****************************************************************************
 * addValue()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void addValue(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  modifyField firstfld, currfld,
  newfld = NULLModifyField, lastfld = NULLModifyField;
  QyModifyValue value;
  QyModifyAttr attr;
  Widget form, attrbutton;
  Arg args[MAXARGS];
  
  firstfld = (modifyField) closure;
  attr = firstfld->this_attr;
  
  for (currfld = firstfld;
       currfld != NULLModifyField &&
       currfld->this_attr == attr;
       currfld = currfld->next)
    {
      value = currfld->this_value;
      
      if (value->value == NULLString &&
	  value->new_value == NULLString &&
	  currfld->edit == NULLWidget)
	newfld = currfld;
      
      if (currfld->edit != NULLWidget)
	lastfld = currfld;
      
      if (currfld->next == NULLModifyField || currfld->next->this_attr!= attr)
	break;
    }
  
  if (newfld == NULLModifyField)
    /**************************************************
     *
     * No discarded field records, create a new one.
     * 
     */
    {
      newfld = mod_field_alloc();
      
      newfld->changed = FALSE;
      newfld->is_active = FALSE;
      
      newfld->is_rdn = FALSE;
      newfld->is_must = lastfld->is_must;
      
      newfld->edit = NULLWidget;
      newfld->this_attr = attr;
      newfld->syntax = attr->attr_type->oa_syntax;
      
      newfld->next = currfld->next;
      currfld->next = newfld;
      
      value = newfld->this_value = modify_value_alloc();
      
      currfld->this_value->next = value;
      value->next = NULLModifyValue;
      
      value->value = value->new_value = NULLString;
      value->status = QMVunchanged;
    }
  
  /**************************************************
   *
   * Create the actual field.
   * 
   */
  
  form = XtParent(lastfld->edit);
  
  XtSetArg(args[0], XmNleftWidget, &attrbutton);
  XtGetValues(lastfld->edit, args, 1);
  
  XtSetArg(args[0], XmNleftWidget, &attrbutton);
  XtGetValues(attrbutton, args, 1);
  
  (void) createValueEdit(attrbutton, lastfld->edit, form, newfld);
} /* addValue */

/*****************************************************************************
 * deleteValue()
 *
 * Delete the given field value;
 *
 ****************************************************************************/

/* ARGSUSED */
static void deleteValue(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Widget edit, nextedit, prevedit, valbutton;
  modifyField field;
  QyModifyValue value;
  Arg args[MAXARGS];
  XtPointer ptr;
  
  field = (modifyField) closure;
  edit = field->edit;
  value = field->this_value;
  
  if (value->new_value != NULLString)
    {
      XtFree(value->new_value);
      value->new_value = NULLString;
    }
  
  /**************************************************
   *
   * If other edit fields for this value exist,
   * then delete this one.
   * 
   */
  
  XtSetArg(args[0], XmNuserData, &ptr);
  XtGetValues(edit, args, 1);

  nextedit = (Widget) ptr;

  XtSetArg(args[0], XmNtopWidget, &prevedit);
  XtGetValues(edit, args, 1);
  
  if (prevedit != NULLWidget || nextedit != NULLWidget)
    {
      if (nextedit != NULLWidget)
	{
	  /* Re-organize next field edit. */
	  
	  XtSetArg(args[0], XmNleftWidget, &valbutton);
	  XtGetValues(nextedit, args, 1);
	  
	  if (prevedit != NULLWidget)
	    {
	      XtSetArg(args[0], XmNtopAttachment, XmATTACH_WIDGET);
	      XtSetArg(args[1], XmNtopWidget, prevedit);

	      XtSetValues(nextedit, args, 2);
	      XtSetValues(valbutton, args, 2);
	    }
	  else
	    {
	      XtSetArg(args[0], XmNtopAttachment, XmATTACH_FORM);

	      XtSetValues(nextedit, args, 1);
	      XtSetValues(valbutton, args, 1);
	    }
	  
	  /* Set traversal information */
	  if (prevedit != NULLWidget)
	    {
	      XtSetArg(args[0], XmNuserData, (XtPointer) nextedit);
	      XtSetValues(prevedit, args, 1);
	    }
	}
      
      if (prevedit != NULLWidget)
	{
	  ptr = (XtPointer) nextedit;
	  XtSetArg(args[0], XmNuserData, ptr);
	  XtSetValues(prevedit, args, 1);
	}
      
      /* Destroy deleted field widgets. */
      XtSetArg(args[0], XmNleftWidget, &valbutton);
      XtGetValues(edit, args, 1);
      
      XtDestroyWidget(edit);
      XtDestroyWidget(valbutton);
    }
  else
    {
      XtSetArg(args[0], XmNvalue, "");
      XtSetValues(edit, args, 1);
    }
  
  field->changed = TRUE;
  value->status = QMVdeleted;
} /* deleteValue */

/*****************************************************************************
 * undoChanges()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void undoChanges(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Widget edit;
  modifyField field;
  QyModifyValue value;
  String strval;
  Arg args[MAXARGS];
  
  field = (modifyField) closure;
  edit = field->edit;
  value = field->this_value;
  
  if (value->new_value != NULLString)
    {
      XtFree(value->new_value);
      value->new_value = NULLString;
    }
  
  if (value->value != NULLString)
    strval = value->value;
  else
    strval = "";
  
  if (field->edit != NULLWidget)
    {
      if (field->syntax >= AV_WRITE_FILE)
	{
	  XtSetArg(args[0], XmNvalue, "");
	}
      else if (field->syntax == str2syntax("dn"))
	{
	  char ufname[LINESIZE];
	  
	  QyPrintFriendlyDN(strval, ufname);
	  XtSetArg(args[0], XmNvalue, ufname);
	}
      else
	{
	  XtSetArg(args[0], XmNvalue, strval);
	}      
      
      XtSetValues(edit, args, 1);
    }
  
  field->changed = FALSE;
  value->status = QMVunchanged;
} /* undoChanges */

/*****************************************************************************
 * undoAllChanges()
 *
 * Undo changes to all values of a given attribute.
 *
 ****************************************************************************/

/* ARGSUSED */
static void undoAllChanges(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Widget nextedit, prevedit, firstedit, attrbutton, form;
  modifyField field;
  QyModifyValue value;
  QyModifyAttr attr;
  Arg args[MAXARGS];
  XtPointer ptr;
  
  field = (modifyField) closure;
  attr = field->this_attr;
  
  /**************************************************
   *
   * Get the first edit field widget, attribute
   * menu button, attribute and top form.
   * 
   */
  
  firstedit = NULLWidget;
  while (field != NULLModifyField && field->this_attr == attr)
    {
      if (field->edit != NULLWidget)
	{
	  firstedit = field->edit;
	  
	  XtSetArg(args[0], XmNleftWidget, &attrbutton);
	  XtGetValues(firstedit, args, 1);
	  XtGetValues(attrbutton, args, 1);
	  
	  form = XtParent(firstedit);
	  
	  break;
	}

      field = field->next;
    }
  
  /**************************************************
   *
   * Undo changes in each field.
   * 
   */
  
  field = (modifyField) closure;
  prevedit = NULLWidget;
  
  while (field != NULLModifyField && field->this_attr == attr)
    {
      if (field->changed == TRUE)
	{
	  value = field->this_value;
	  
	  /**************************************************
	   *
	   * Re-create widget if it has been deleted.
	   * 
	   */
	  
	  if (field->edit == NULLWidget && value->value != NULLString)
	    {
	      if (prevedit != NULLWidget)
		{
		  XtSetArg(args[0], XmNuserData, &ptr);
		  XtGetValues(prevedit, args, 1);

		  nextedit = (Widget) ptr;
		}
	      else
		nextedit = firstedit;
	      
	      field->edit = createValueEdit(attrbutton,
					    prevedit,
					    form,
					    field);
	      
	      /* Place new edit widget in traversal chain */
	      if (nextedit != NULLWidget)
		{
/*		  XtSetArg(args[0], XmNuserData, (XtPointer) field->edit); */
		  XtSetArg(args[0], XmNtopWidget, field->edit);
		  XtSetValues(nextedit, args, 1);
		}

	      XtSetArg(args[0], XmNuserData, (XtPointer) nextedit);
	      XtSetValues(field->edit, args, 1);

	      if (prevedit != NULLWidget)
		{
		  XtSetArg(args[0], XmNuserData, (XtPointer) field->edit);
		  XtSetValues(prevedit, args, 1);
		}
	    }
	  
	  undoChanges(NULLWidget, (XtPointer) field, (XtPointer) NULL);
	}
      
      if (field->edit != NULLWidget)
	prevedit = field->edit;

/* 
/*       if (field->next == NULLModifyField || field->next->this_attr != attr)
/* 	{
/* 	  XtSetArg(args[0], XmNbottomAttachment, XmATTACH_FORM);
/* 	  XtSetValues(prevedit, args, 1);
/* 	}
 */      
      field = field->next;
    }
} /* undoAllChanges */

/*****************************************************************************
 * createValueEdit()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static Widget createValueEdit(horiz, vert, form, field)
     Widget horiz;
     Widget vert;
     Widget form;
     modifyField field;
{
  Widget newedit, valbutton, menubutton, rowcol;
  AttributeType type;
  QyModifyValue value;
  int count;
  Arg args[MAXARGS];
  String strval;
  Dimension horiz_width, form_width;
  XmString labelstr;
  
  value = field->this_value;
  if (value->status == QMVdeleted)
    return NULLWidget;
  
  type = field->this_attr->attr_type;
  
  count = 0;
  XtSetArg(args[count], XmNwidth, &horiz_width); count++;
  XtGetValues(horiz, args, count);
  
  count = 0;
  XtSetArg(args[count], XmNwidth, &form_width); count++;
  XtGetValues(XtParent(form), args, count);
  
  /* Allow for scroll bars */
  form_width -= (AttributeDefaultDistance * 3);
  
  /***************************************************
   *
   * Create per-value menu.
   *
   */
  
  count = 0;

  if (vert != NULLWidget)
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
      XtSetArg(args[count], XmNtopWidget, vert); count++;
    }
  else
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_FORM); count++;
    }
  
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftWidget, horiz); count++;
  
  XtSetArg(args[count], XmNheight, MenuDimension); count++;
  XtSetArg(args[count], XmNwidth, MenuDimension); count++;

  labelstr = XmStringCreateSimple("");

  XtSetArg(args[count], XmNlabelString, labelstr); count++;
  XtSetArg(args[count], XmNrecomputeSize, FALSE); count++;
  XtSetArg(args[count], XmNshadowThickness, 1); count++;
  
  valbutton = XmCreateLabel(form, "valMenuButton", args, count);
  XmStringFree(labelstr);

  XmAddTabGroup(valbutton);
  XtManageChild(valbutton);

  XtSetArg(args[0], XmNmenuPost, "<Btn1Down>");
  rowcol = XmCreatePopupMenu(valbutton, "menu", args, 1);
  
  /***************************************************
   *
   * Menu entries.
   *
   */
  
  menubutton = XmCreatePushButton(rowcol, "undoChanges", args, 0);
  XtManageChild(menubutton);

  XtAddCallback(menubutton,
		XmNactivateCallback,
		undoChanges,
		(XtPointer) field);

  menubutton = XmCreatePushButton(rowcol, "deleteValue", args, 0);
  XtManageChild(menubutton);

  XtAddCallback(menubutton,
		XmNactivateCallback,
		deleteValue,
		(XtPointer) field);

  XtAddEventHandler(valbutton,
		    ButtonPressMask,
		    FALSE,
		    XLUpostMenu,
		    rowcol);
  
  /***************************************************
   *
   * Edit field.
   *
   */
  
  if (value->new_value != NULLString)
    strval = value->new_value;
  else if (value->value != NULLString && value->status != QMVnew)
    strval = value->value;
  else
    strval = "";	    
  
  modCallback[0].closure = (XtPointer) field;
  
  count = 0;
  
  if (type->oa_syntax >= AV_WRITE_FILE)
    {
      XtSetArg(args[count], XmNvalue, ""); count++;
    }
  else if (type->oa_syntax == str2syntax("dn"))
    {
      char ufname[LINESIZE];
      
      QyPrintFriendlyDN(strval, ufname);
      XtSetArg(args[count], XmNvalue, ufname); count++;
    }
  else
    {
      XtSetArg(args[count], XmNvalue, strval); count++;
    }
  
  XtSetArg(args[count], XmNrightAttachment, XmATTACH_FORM); count++;
  XtSetArg(args[count], XmNleftAttachment, XmATTACH_WIDGET); count++;
  XtSetArg(args[count], XmNleftWidget, valbutton); count++;
  
  if (vert != NULLWidget)
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_WIDGET); count++;
      XtSetArg(args[count], XmNtopWidget, vert); count++;
    }
  else
    {
      XtSetArg(args[count], XmNtopAttachment, XmATTACH_FORM); count++;
    }
  
  XtSetArg(args[count], XmNresizable, TRUE); count++;
  XtSetArg(args[count], XmNmodifyVerifyCallback, modCallback); count++;

  XtSetArg(args[count], XmNbottomAttachment, XmATTACH_NONE); count++;
  XtSetArg(args[count], XmNresizeHeight, TRUE); count++;

  newedit = XmCreateText(form, "modifyEdit", args, count);

  XmAddTabGroup(newedit);
  XtManageChild(newedit);
  
  /***************************************************
   *
   *	Save pointer to the edit widget,
   *	then make sure that this is deleted o
   *	widget destruction.
   *
   */
  
  field->edit = newedit;
  XtAddCallback(newedit,
		XmNdestroyCallback,
		modifyFieldDestroyed,
		(XtPointer) field);
  
  /***************************************************
   *
   * Save sequence info.
   *
   */
  
  if (vert != NULLWidget)
    {
      XtSetArg(args[0], XmNuserData, (XtPointer) newedit);
      XtSetValues(vert, args, 1);
    }
  else
    {
      XtSetArg(args[0], XmNuserData, (XtPointer) newedit);
      XtSetValues(form, args, 1);
    }
  
  /***************************************************
   *
   * Make bitmap for menu button.
   *
   */
  
/*
  (void) strcpy(bitmap_file_name, bitmap_directory);
  (void) strcat(bitmap_file_name, "menu12");
  
  create_background_from_bitmap_file(valbutton, bitmap_file_name);
*/

  return newedit;
} /* createValueEdit */

