#ifndef _Xlu_update1_h_
#define _Xlu_update1_h_

#include "configure.h"

/***************************************************
 *
 * Data structures used to manipulate
 * and maintain edit fields.
 *
 */

typedef struct modifyField
{
  BOOLEAN changed;
  BOOLEAN is_active;
  BOOLEAN is_rdn;
  BOOLEAN is_must;

  Widget edit;
  int syntax;

  QyModifyValue this_value;
  QyModifyAttr this_attr;

  struct modifyField *next;
} *modifyField;

#define NULLModifyField (modifyField) NULL
#define mod_field_alloc() (modifyField) XtNew(struct modifyField)

typedef struct modifyGroup
{
  XLUattributeGroup group;
  modifyField fields;

  struct modifyGroup *next;
} *modifyGroup;

#define NULLModifyGroup (modifyGroup) NULL
#define mod_group_alloc() (modifyGroup) XtNew(struct modifyGroup)

typedef struct modifyEntry
{
  modifyGroup groups;
  QyModifyAttr undisplayed;
  String name;
  String current_dn;
} *modifyEntry;

#define NULLModifyEntry (modifyEntry) NULL
#define mod_entry_alloc() (modifyEntry) XtNew(struct modifyEntry)

/***************************************************
 *
 * Modify form status.
 *
 */

typedef enum {Composing, Modifying, NoEntry} XLUupdateState;
typedef struct XLUupdateContext
{
  XLUupdateState state;
  BOOLEAN changes;
  XLUentryClass class;
  String name;
  modifyEntry modentry;
} *XLUupdateContext;

#define NULLXLUupdateContext (XLUupdateContext) NULL
#define update_state_alloc() (XLUupdateContext) XtNew(struct XLUupdateContext)

/***************************************************
 *
 * Public functions.
 *
 */

void doModifyAction();
void initModifyStatusData();

void doUpdateModifyForm();
void displayClassTemplate();

void displayEntryTemplate();
void gotEntryTemplateResult();

void displayNextGroup();
void displayPreviousGroup();

void changeModifyFocus();
void getModifyFocus();

void changeDialogFocus();
void setDialogFocus();

void setUpdateState();
void getUpdateState();

#endif /* _Xlu_update1_h_ */

