/*****************************************************************************

  widgets.h - Declarations for widget/part  creation functions.

*****************************************************************************/

#ifndef _Xlu_widgets_h
#define _Xlu_widgets_h

#include "windows.h"
#include "defs.h"
#include "actions.h"

typedef struct primInfo
{
  int primitive_id;
  int object_id;
  int action_id;
} *primInfo;

#define NULLPrimInfo (primInfo) NULL
#define prim_info_alloc() (primInfo) XtNew(struct primInfo)

/***************************************************
 *
 * Global functions..
 *
 */

void XLUloadActions();

Widget XLUmakeButton();
Widget XLUmakeUFNdialog();
Widget XLUmakeStatusBar();
Widget XLUmakeLabel();
Widget XLUmakeEntryViewer();
Widget XLUmakeFormDialog();
Widget XLUmakeListViewer();
Widget XLUmakeModifyDialog();
Widget XLUmakeErrorViewer();
Widget XLUmakeLogViewer();
Widget XLUmakeHelpViewer();

/*
Widget makeButton();
Widget makeMoveto();
Widget makeStatusLabel();
Widget makeTitleBar();
Widget makeReadDisplay();
Widget makeSearchGroup();
Widget makeListDisplay();
Widget makeHelpDisplay();
Widget makeModifyWindow();
Widget makeErrorViewer();
Widget makeLogViewer();
*/

#endif /* _Xlu_widgets_h */


