#ifndef _Xlu_xutil_h_
#define _Xlu_xutil_h_

#include <Xm/Xm.h>

/* Context data for primitive window objects */
typedef struct XLUprimitiveData
{
  int type;	/* Type of primitive (e.g. ENTRY_DISPLAY, HELP, BUTTON) */
  int actid;	/* Action identifier */
  XtPointer userdata;  /* Primitive specific data */
  XtCallbackProc cleanup;  /* Clean up "userdata" */
} *XLUprimitiveData;

/***************************************************
 *
 * Public functions.
 *
 */

void get_widget_geometry();
void set_widget_dimensions();

void create_background_from_bitmap_file();
Pixmap create_bitmap_from_file();

BOOLEAN get_dims_of_bitmap_file();
void XLUgetTextExtents();

void XLUappendXmString();
void XLUappendSeparatorXmString();

void XLUaddContextEntry();
void XLUremoveContextEntry();

void XLUfreeStorage();
void XLUfreePixmap();

void XLUplaceWindow();
void XLUpostMenu();

void XLUsetWMHandler();

String XLUgetListString();
String XLUgetXmStringText();

void XLUsavePrimitiveContext();
void XLUsavePrimitiveData();
int XLUgetPrimitiveType();
int XLUgetPrimitiveActionID();
XtPointer XLUgetPrimitiveData();

#endif /* _Xlu_xutil_h_ */

